# when.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  W   W H   H EEEEE N   N
#  W   W H   H E     NN  N
#  W W W HHHHH EEEE  N N N
#  W W W H   H E     N  NN
#   W W  H   H EEEEE N   N
#
=begin ###########################################################
#=Date::Extended                                                 #
\===@t̓tƎ                                         #
$===The class which represents date and time with calendar       #
#                                                                #
\==X[p[NX:                                               #
$==Super Class:                                                  #
#*Date*                                                          #
=end #############################################################

require 'rational' unless Object.const_defined?('Rational')
require 'when/func'
require 'when/calendar'
require 'when/format'

class Date

=begin #########################################################
\==Date NX ǉ NX \bh:                           #
$==Additional Class Method of Date Class:                      #
=end ###########################################################
  class << self

=begin ***********
#--- Date.utc([cal=Civil.new,] y [, m [, d [, h [, min [, s [, us]]]]]])
\  UTCŎw肳ꂽ Date+IuWFNg𐶐܂B
\  ts̏ꍇ  ArgumentError 𔭐܂B
\  ȉȂꍇ́An߂ɑΉ Date+IuWFNg𐶐܂B
\  ȉȂꍇ́A^p̔NɑΉ Date+IuWFNg𐶐
\  (͗@ɂẮA11ȊOɂȂ܂)B
\
\    cal  Calendar+IuWFNg܂͂w肷镶
\    y    N
\    m    
\    d    
\    h    
\    min  
\    s    b
\    us   b̏(under second)
=end =============
    def utc(*date)
      unless (a = Calendar.select(date))
        raise ArgumentError, 'invalid date'
      end
      zone = Timezone.new(0)
      Extended.new_date(a[0], zone.sd_to_jd(a[2]), zone)
    end

=begin ***********
#--- Date.local([cal=Civil.new,] y [, m [, d [, h [, min [, s [, us]]]]]])
\  [J^CŎw肳ꂽ Date+IuWFNg𐶐܂B
\  ts̏ꍇ ArgumentError 𔭐܂B
\  ȉȂꍇ́An߂ɑΉ Date+IuWFNg𐶐܂B
\  ȉȂꍇ́A^p̔NɑΉ Date+IuWFNg𐶐
\  (͗@ɂẮA11ȊOɂȂ܂)B
\
\    cal  Calendar+IuWFNg܂͂w肷镶
\    y    N
\    m    
\    d    
\    h    
\    min  
\    s    b
\    us   b̏(under second)
=end =============
    def local(*date)
      unless (a = Calendar.select(date))
        raise ArgumentError, 'invalid date'
      end
      zone = Timezone.zone
      Extended.new_date(a[0], zone.sd_to_jd(a[2]), zone)
    end

=begin ***********
#--- Date.when?([cal=Civil.new,] y [, m [, d [, h [, min [, s [, us]]]]]])
\  [J^CŎw肳ꂽ Date+IuWFNg𐶐܂B
\  ts̏ꍇ nil Ԃ܂B
\  ȉȂꍇ́An߂ɑΉ Date+IuWFNg𐶐܂B
\  ȉȂꍇ́A^p̔NɑΉ Date+IuWFNg𐶐
\  (͗@ɂẮA11ȊOɂȂ܂)B
\
\    cal  Calendar+IuWFNg܂͂w肷镶
\    y    N
\    m    
\    d    
\    h    
\    min  
\    s    b
\    us   b̏(under second)
=end =============
    def when?(*date)
      return nil unless a = Calendar.select(date)
      zone = Timezone.zone
      Extended.new_date(a[0], zone.sd_to_jd(a[2]), zone)
    end
  end # of Date class methods

=begin #########################################################
\==Date NX ǉ pubN CX^X \bh:          #
$==Additional Public Instance Method of Date Class:            #
=end ###########################################################
  public

=begin ***********
#--- Date#cal
\  self gpĂ Calendar+IuWFNgԂ܂B
=end =============
  def cal() to_extended.cal end
  class Extended < Date; def cal() @cal end end

=begin ***********
#--- Date#timezone
\  self gpĂ Timezone+IuWFNgԂ܂B
=end =============
  def timezone() to_extended.zone end
  class Extended < Date; def timezone() @zone end end

=begin ***********
#--- Date#sd
\  nʓԂ܂B
=end =============
  if Date.method_defined?('strftime')
    def sd() (rjd + of) end
  else
    def sd() jd  end
  end
  class Extended < Date
    def sd
      @zone.jd_to_sd(@rjd)
    end
  end

=begin ***********
#--- Date#sdn
\  nߒʓ(*)Ԃ܂B
\  * sd ̏_ȉۂ߂
\
\  1̎n܂̎@ɂĈقȂ邽߁Aۂ߂͕Kľܓ
\  ͂܂B{\bh͕K߂ɑΉ sdn (Serial Day Number
\  ܂ Serial Day Noon ̂ - ̓EXʓƂ̊֌WȂ
\  \̂ŁALocal Day Number Ƃ͂Ȃ)Ԃ܂B
=end =============
  alias_method :sdn, :jd
  class Extended < Date; def sdn() @cal.round_day(sd) end end

=begin ***********
#--- Date#sdf
\  sd - sdn Ԃ܂BłƂ͌܂B
=end =============
  def sdf()  sd - sdn end

=begin ***********
#--- Date#fr1
\  sdf + 1/2 Ԃ܂B
=end =============
  def fr1()  sdf + 1.to_r / 2 end

=begin ***********
#--- Date#rjd
\  EXʓ(-4712-01-01T12:00:00Žoߎ(P ))Ԃ܂B
=end =============
  unless Date.method_defined?('strftime')
    def rjd() jd end
  end
  class Extended < Date; def rjd() @rjd end end

=begin ***********
#--- Date#jdn
\  rjd ̏_ȉľܓ( Julian Day Number ܂ Julian Day
\  Noon ̂)Ԃ܂B
=end =============
  if Date.method_defined?('strftime')
    def jdn() (rjd + 1.to_r/2).floor end
  else
    def jdn() jd end
  end
  class Extended < Date; def jdn() (rjd+1.to_r/2).floor end end

=begin ***********
#--- Date#jdf
\  rjd - jdn Ԃ܂BłƂ͌܂B
=end =============
  def jdf()  rjd - jdn end

=begin ***********
#--- Date#zone
\  ^C][ItZbgԂ܂B
=end =============
  unless Date.method_defined?('strftime')
    def zone()  0  end
  end
  class Extended < Date; def zone() @zone.zone(sd) end end

=begin ***********
#--- Date#new_calendar(cal)
#--- Date#%(cal)
\  self 𕡐āAgp Calendar+IuWFNgݒ肵܂B
\
\    cal  Calendar+IuWFNg܂͂w肷镶
=end =============
  def new_calendar(cal)
    return new_start(cal) unless Calendar === cal || String === cal 
    to_extended.new_calendar(cal)
  end
  class Extended < Date
    def new_calendar(cal)
      case cal
      when Calendar;  new_cal = cal
      when Numeric;   new_cal = Civil.new(cal.to_i)
      when String
        unless (new_cal = Calendar.get(cal))
          raise ArgumentError, 'invalid calendar name'
        end
      else; raise TypeError, 'invalid calendar type'
      end
      type.new_date(new_cal, @rjd, @zone)
    end
  end

=begin ***********
#--- Date#new_zone(zone)
#--- Date#|(zone)
\  self 𕡐āAgp鎞ݒ肵܂B
\
\    zone Timezone+IuWFNg܂͂w肷鐔lor
=end =============
  def new_zone(zone) to_extended.new_zone(zone) end
  class Extended < Date
    def new_zone(zone)
      case zone
      when Timezone; new_zone = zone
      when Numeric;  new_zone = Timezone.new(zone)
      when String
        unless (new_zone = Timezone.get(zone))
          raise ArgumentError, 'invalid timezone name'
        end
      else; raise TypeError, 'invalid timezone type'
      end
      type.new_date(@cal, @rjd, new_zone)
    end
  end

=begin ***********
#--- Date#new_period(period)
#--- Date#/(period)
\  self [_ƂA period  Period+IuWFNg𐶐܂B
\  I_͊ԂɊ܂܂܂B
\  (Period+IuWFNg쐬̂߁ARange*IuWFNg
\   Ԃ܂)
\
\    period Ԃ ISO8601ԕ
=end =============
  def new_period(period)
    period =~ /([\/]*)$/
    if ($1.length % 2) == 0 then  self...(self+period)
    else                          (self+period)...self
    end
  end

=begin ***********
#--- Date#show_all_date([k=true [, n=true]])
\  Nb̏܂łׂ̂Ă̗vfԂ܂B
\
\    k  L k Ԗڂ̓t\ɑΉlԂ悤w܂B
\       true Ȃ΁AׂĂ̗Lȓt\zŕԂ܂B
\    n  true ȂNb̏܂łׂĂ̗vfԂ܂B
\       lȂ΁AΉvf݂̂Ԃ܂B
=end =============
  def show_all_date(k=true, n=true)
    to_extended.show_all_date(k,n)
  end
  class Extended < Date
    def show_all_date(k=true, n=true)
      a = @cal.sd_to_date(sd, k)
      return a unless Numeric === n && (0..6) === n
      case k
      when false; return  a
      when true;  return (a.collect {|s| s[n]})
      else;       return  a[n]
      end
    end
  end
  def hour(k=1)   show_all_date(k, 3) end
  def minute(k=1) show_all_date(k, 4) end
  def second(k=1) show_all_date(k, 5) end
  def usec(k=1)   show_all_date(k, 6) end

=begin ***********
#--- Date#+(n)
\  self  n  Date*IuWFNgԂ܂B
\
\    n  l(Numeric*)̏ꍇAn  Date*IuWFNgԂ܂B
\       ](Residue+)̏ꍇA܂͈ȍ~̓tōŏɏ𖞂
\       Date*IuWFNgԂ܂B
\       (String*)̏ꍇAΉ]܂ISO8601ԕ
\       āA̎wɏ]܂B
=end =============
  alias_method :plus, :+
  def + (x)
    return plus(x) if Numeric === x
    to_extended + x
  end

  class Extended < Date
    def + (x)
      case x
      when Numeric
        type.new_date(@cal,@zone.sd_to_jd(x+sd),@zone)
      when Residue
        type.new_date(@cal,@zone.sd_to_jd(x+@cal.round_day(sd)),@zone)
      when String
        if (r = Residue.get(x))
          type.new_date(@cal,@zone.sd_to_jd(r+@cal.round_day(sd)),@zone)
        else
          type.new_date(@cal,@zone.sd_to_jd(@cal.shift_sd(sd,x)),@zone)
        end
      else
        raise ArgumentError, 'invalid offset'
      end
    end
  end

=begin ***********
#--- Date#-(x)
\  x  Date*IuWFNgȂAself  x Ƃ̊Ԃ̓Ԃ܂B
\  ̑̃IuWFNgȂ x O Date*IuWFNgԂ܂B
\
\    x  t(Date*)̏ꍇAself  x Ƃ̊Ԃ̓Ԃ܂B
\       l(Numeric*)̏ꍇAx O Date*IuWFNgԂ܂B
\       ](Residue+)̏ꍇAȑO̓tōŌɏ𖞂 Date* 
\       IuWFNgԂ܂B
\       (String*)̏ꍇAΉ]܂ISO8601ԕ
\       āA̎wɏ]ċ߂ Date*IuWFNgԂ܂B
=end =============
  alias_method :minus , :-
  def - (x)
    return minus(x) if Numeric === x
    to_extended - x
  end

  class Extended < Date
    def - (x)
      case x
      when Numeric
        return type.new_date(@cal,@zone.sd_to_jd(-x+sd),@zone)
      when Residue
        return type.new_date(@cal,@zone.sd_to_jd(-x+@cal.round_day(sd)),@zone)
      when Date;    return rjd - x.rjd
      when String
        if (r = Residue.get(x))
          return type.new_date(@cal,@zone.sd_to_jd(-r+@cal.round_day(sd)),@zone)
        else
          return type.new_date(@cal,@zone.sd_to_jd(@cal.shift_sd(sd, x+'/')),@zone)
        end
      else
        raise ArgumentError, 'invalid offset'
      end
    end
  end

=begin ***********
#--- Date#<=>(other)
\  ҂rāA-1, 0, 1Ԃ܂B
\
\    other  rΏۂ Numeric*, Date*IuWFNg
=end =============
  def <=> (other)
    case other
    when Numeric; return rjd <=> other
    when Date;    return rjd <=> other.rjd
    end
    raise TypeError, 'expected numeric or date'
  end

=begin ***********
#--- Date#===(other)
\  ҂̃EXʓ(rjd)rāAvĂΐ^Ԃ܂B
\
\    other  rΏۂ Numeric*, Date*IuWFNg
=end =============
  def === (other)
    case other
    when Numeric; return rjd == other
    when Date;    return rjd == other.rjd
    end
    raise TypeError, 'expected numeric or date'
  end

=begin ***********
#--- Date#[](key)
\  key Ŏw肵Ԃ܂B
\
\    key    
=end =============
  def [](key)
    to_extended[key]
  end
  class Extended < Date
    def [](key)
      q = @@q
      key.split('.').each do |k|
        case q[k]
        when Hash; q = q[k]
        when Array; return q[k][0].call(self)
        when Proc;  return q[k].call(self)
        when nil;   return false
        else raise ArgumentError, 'invalid calendar element'
        end
      end
      q.keys.collect do |k|
        self[key+'.'+k]
      end
    end
  end

=begin ***********
#--- Date#to_extended
\  Date*IuWFNgDate::Extended+IuWFNgɕϊĕԂ܂B
\
=end =============
  if Date.method_defined?('strftime')
    def to_extended() Extended.new0(Civil.new(sg), rjd, Timezone.new(of)) end
  else
    def to_extended() Extended.new0(Civil.new(sg), jd, Timezone.new(0)) end
  end

=begin #########################################################
\==Date::Extended NX ϐ:                                 #
$==Class Variable Date::Extended Class:                        #
=end ###########################################################
  class Extended < Date
    @@q = {
      '\'  => [proc{|d| %w( b     
                                M h p  )   [(d.sdn - 11) % 10]}],
      '\x'=> [proc{|d| %w( q N  K C 
                                 \    )[(d.sdn - 11) % 12]}],
      'x'  => [proc{|d| d['\'] + d['\x']}]
    }

=begin #########################################################
\==Date::Extended NX \bh:                             #
$==Class Method of Date::Extended Class:                       #
=end ###########################################################
    class << self

=begin ***********
#--- Extended._load(str)
\  Marshal*  Extended+IuWFNg̓ǂݍ݂ɗp܂B
\  (,Calendar  singleton ̏ꍇ̑Ήv)
\
\    str  Marshal* ꂽ
=end =============
      def _load(str) new0(*Marshal.load(str)) end

=begin ***********
#--- Extended.new_date(cal, rjd, zone)
\  w肳ꂽEXʓDate*/Date::Extended+IuWFNg𐶐܂B
\  ]OYt Date NX̃IuWFNĝ́Acal  Civil, 
\  rjd, zone  0 ̏ꍇłBVo[W Date NX̃IuWFN
\  ĝ cal  Civil, zone Œ̏ꍇłB
\
\    cal   Calendar+IuWFNg
\    rjd   EXʓ
\    zone  Timezone+IuWFNg
=end =============
      if Date.method_defined?('strftime')
        def new_date(cal, rjd, zone)
          unless cal.type == Civil && zone.type == Timezone
            return new0(cal, rjd, zone) 
          end
          h = cal.to_hash.dup
          b = Civil.new.to_hash
          b['Title']             = h['Title']  = nil
          b['Reform_JD']         = h['Reform_JD'] 
          b['TimeUnits'][1][0]   = h['TimeUnits'][1][0]
          return new0(cal, rjd, zone) unless h == b
          return Date.new0(rjd, zone.zone, cal['Reform_JD'])
        end
      else
        def new_date(cal, rjd, zone)
          unless cal.type == Civil && zone.type == Timezone
            return new0(cal, rjd, zone) 
          end
          h = cal.to_hash.dup
          b = Civil.new.to_hash
          b['Title']             = h['Title']  = nil
          b['Reform_JD']         = h['Reform_JD'] 
          b['TimeUnits'][1][0]   = h['TimeUnits'][1][0]
          return new0(cal, rjd, zone) unless h == b
          if rjd == rjd.floor && zone.zone == 0  
            return Date.new1(rjd.floor, cal['Reform_JD'])
          end
          return new0(cal, rjd, zone)
        end
      end
    end # of Date::Extended class methods

=begin ***********
#--- Extended.new0(cal, rjd, zone)
\  w肳ꂽEXʓ Extended+IuWFNg𐶐܂B
\
\    cal   Calendar+IuWFNg
\    rjd   EXʓ
\    zone  Timezone+IuWFNg
\
\*CX^Xϐ
\  @cal  Calendar+IuWFNg
\  @rjd  EXʓ
\  @zone Timezone+IuWFNg
=end =============
    def initialize(cal, rjd, zone)
      @cal, @rjd, @zone = cal, rjd, zone
    end

=begin #########################################################
\==Date::Extended NX pubN CX^X \bh:     #
$==Public Instance Method of Date::Extended Class:             #
=end ###########################################################

=begin ***********
#--- Extended#yday
\  N̒ʎZ(1`N̓)Ԃ܂B
\  ^p\̔NƗ@̔NقȂꍇ́A^p̔NƂ܂B
=end =============
    def yday
       (sdn - @cal.date_to_sd(year)).to_i + 1
    end

=begin ***********
#--- Extended#wday
\  jԂ܂(j:0, ... yj:6)B
\  ^p\̓̋؂肪ߑO0łȂꍇA^p\̓tƂ܂B
\  (ႦΗ[1n܂ꍇAߑO0O1i񂾎jԂ܂)
=end =============
    def wday
       (sdn + 1) % 7
    end

=begin ***********
#--- Extended#>>(n)
\  n  Extended+IuWFNgԂ܂B
\
\    n  Numeric*IuWFNg
=end =============
    def >> (n)
      type.new0(@cal, timezone.sd_to_jd(@cal.shift_sd_m(sd, n)),  @zone)
    end

=begin ***********
#--- Extended#year ([k=1])
#--- Extended#month ([k=1])
#--- Extended#day ([k=1])
#--- Extended#hour ([k=1])
#--- Extended#minute ([k=1])
#--- Extended#second ([k=1])
#--- Extended#usec ([k=1])

#--- Extended#mon ([k=1])
#--- Extended#mday ([k=1])
#--- Extended#min ([k=1])
#--- Extended#sec ([k=1])
\  ꂼANEEEEEbEb̏, EEEbԂ܂B
\  (uv͌̒ʎZ(1 ܂ 0`̓))
\
\    k  L k Ԗڂ̓t\ɑΉlԂ悤w܂B
\      (@Ƃ Eras+IuWFNggpĂꍇ)
=end =============
    def year(k=1)   show_all_date(k, 0) end
    def month(k=1)  show_all_date(k, 1) end
    def day(k=1)    show_all_date(k, 2) end
    def hour(k=1)   show_all_date(k, 3) end
    def minute(k=1) show_all_date(k, 4) end
    def second(k=1) show_all_date(k, 5) end
    def usec(k=1)   show_all_date(k, 6) end

=begin ***********
#--- Extended#lapse([leap=false]
\  1970-01-01T00:00:00Z ̌oߕbԂ܂B
\  b̏ꍇ́Afalse Ԃ܂B
\  ([b̍l͂܂Ă܂)
\
\    leap  [blƂ true, lȂƂ false
=end =============
    def lapse(leap=false)
      s = (rjd - (Timezone::UTC_EPOCH + 1.to_r/2)) * 86400
      return false if s < 0
      return leap ? s + Timezone.deltaT(rjd) : s
    end

=begin ***********
#--- Extended#to_s([n=1])
\  ɑΉISO8601gԂ܂B
\
\    n   n Ԗڂ̓\\̑gɕϊ邩w
=end =============
    def to_s(n=1)
      a = @cal.sd_to_s(sd, n)
      z = @zone.to_s_with_dst(rjd)
      case a
      when String; a + z
      when Array;  a.collect{|s| s + z }
      else;        a
      end
    end

=begin ***********
#--- Extended#inspect
\  Kernel* W[Œ`Ăgݍ݊֐ p gp܂B
=end =============
    def inspect()
      format('#<%s: %12.5f (%s) %s:%s [%s]>',
              type, rjd.to_f, cal.day_name_abbr(wday), cal.type, cal._title, to_s)
    end

=begin ***********
#--- Extended#strftime([fmt="%c"])
\  fmt Ŏw肳ꂽ̏ɏ]āA𕶎ɕϊ܂B
\
\    fmt  ̏
=end =============
# defined in date/format.rb

=begin ***********
#--- Extended#_dump(limit)
\  Marshal*  ExtendedIuWFNg̏oɗp܂B
\  (,Calendar  singleton ̏ꍇ̑Ήv)
\
\    limit  ċA𐧌郌x(ۂ͉w肳Ă܂)
=end =============
    def _dump(limit) Marshal.dump([@cal, @rjd, @zone], -1) end

################################################################

    func :rjd, :jdn, :jdf, :fr1, :sd, :sdn, :sdf
    func :lapse, :show_all_date
    alias_method :%,    :new_calendar
    alias_method :|,    :new_zone
    alias_method :mon,  :month
    alias_method :mday, :day
    alias_method :min,  :minute
    alias_method :sec,  :second
  end

  func :jdn, :jdf, :sd, :sdn, :sdf
  func :show_all_date
  alias_method :%,    :new_calendar
  alias_method :|,    :new_zone
  alias_method :/,    :new_period
  alias_method :min,  :minute
  alias_method :sec,  :second
end
