# calendar.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#   CCC    A   L     EEEEE N   N DDDD    A   RRRR 
#  C   C  A A  L     E     NN  N D   D  A A  R   R
#  C     A   A L     EEEE  N N N D   D A   A RRRR 
#  C   C AAAAA L     E     N  NN D   D AAAAA R  R 
#   CCC  A   A LLLLL EEEEE N   N DDDD  A   A R   R
#
=begin #########################################################
#=Calendar                                                     #
\===@̒ۊNX                                       #
$===The pure virtual base class for all calendars              #
\  @`p̃NX́ÃNX̃TuNXƂ܂B      #
\  TuNXł͈ȉ̃\bhĒ`ĂB          #
\    _date_to_sd, _sd_to_date, _qualify                        #
\    _time_to_sd, _sd_to_time (x܂ŕςꍇ)         #
\                                                              #
\  {NX̂̋@\́Aȉ2_łB                       #
\(1) ̏sATuNXt̏ɐOB    #
\(2) ̊O\(^p\)Ɠ\(@)Ƃ̕ϊsB#
\    * N̋EƓ̋Ȅ(\͏11ƌߑO0) #
\    * N̏                                              #
#                                                              #
\==X[p[NX:                                             #
$==Super Class:                                                #
#*Outfit+                                                      #
#                                                              #
\==tŃCN[h郂W[:                       #
$==Conditionally Included Module:                              #
#*Calendar::DayBorder                                          #
#*Calendar::YearBorder                                         #
#*Calendar::YearUnits                                          #
=end ###########################################################

require 'when/initial'

class Calendar < Outfit

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- Calendar.get(key [, all=false])
\  @L[Ƀqbg Calendar+IuWFNg(̃Xg)Ԃ܂B
\
\    key  @(Calendar+)L[
\    all  zԂAqbgʂԂ̎w
=end =============
    def get(key, all=false)
      a = []

      case key
      when Calendar
        a = key._matched_list(false, all)

      when String
        @@outfit['Objs'].each do |obj|
          a += obj._matched_list(key, all)
        end
        unless a.length > 0
          @@outfit['Keys'].each do |item|
            [*item[0]].each do |title|
              if key =~ /#{title}/i
                obj = item[1].call($~.dup)
                return obj unless all
                a += obj._matched_list(key, all)
                break
              end
            end
            break if a.length > 0
          end
        end
      end

      return nil unless a.length > 0
      return (all ? a : a[0][0])
    end

=begin ***********
|--- Calendar._select_without_date_validity(date)
|  \z񂩂Agp Calendar+IuWFNg𒊏oĕԂ܂B
|  t̐̓`FbN܂B
|  (p) z̐擪vf@ŵ݂̂߂̗vf̏ꍇ폜܂B
|  (߂l) [gp@̔z, Ԗڂ̓K@Ƀqbg邩]
|
|    date \z
=end =============
    def _select_without_date_validity(date)
      count = 1
      if Array === date[1] && String === date[1][0]
        Calendar.get(date[ 0])
        cal     = date[1][ 0]
      # cal     = date[0] + '.' + cal if String === date[0]
        count   = date[1][ 1] if date[1].length == 3
        date[1] = date[1][-1]
        date.shift
      elsif Array === date[0] && String === date[0][0]
        cal     = date[0][ 0]
        count   = date[0][ 1] if date[0].length == 3
        date[0] = date[0][-1]
      elsif String === date[0]
        cal     = date.shift
      elsif Calendar === date[0]
        a       = date.shift._matched_list(false, false)
      end
      a ||= Calendar.get(cal, true) if cal
      a ||= Calendar.get(date[1], true)
      a ||= [[Civil.new]]
      return a, count
    end

    private :_select_without_date_validity

=begin ***********
#--- Calendar.select(date)
\  \z񂩂Agp Calendar+IuWFNg𒊏oĕԂ܂B
\  t̐`FbN܂B
\  (p) z̐擪vf@ŵ݂̂߂̗vf̏ꍇ폜܂B
\  (߂l) [gp@, vZp@, nʓ]
\
\    date \z
=end =============
    def select(date)
      a, count = _select_without_date_validity(date)
      return nil unless a

      list, year = [], date[0]
      while a.length > 0
        list = a.shift
        if list.length == 1
          if (sd = list[0].exist?(*date))
            break if (count -= 1) == 0
          end
        else
          date[0] = list[1]['Calendar']._normalize_year(year) *
                    list[1]['Sign'] + list[1]['Epoch']
          next unless (sd = list[1]['Calendar'].exist?(*date))
          sdn = list[1]['Calendar'].round_day(sd)
          next if Numeric === list[1]['Day0'] && sdn <  list[1]['Day0']
          next if Numeric === list[1]['Day1'] && sdn >= list[1]['Day1']
          break if (count -= 1) == 0
        end
      end
      return nil if count > 0
      return list[0], (list.length==1 ? list[0] : list[1]['Calendar']), sd
    end
  end # of class methods

=begin ***********
#--- Calendar.parse(str)
\  str ŗ^ꂽAISO8601`Ȃ(̑̌`ɑΉ)ŕ\ꂽ
\  \镶͂āA͌ʂnbVŕԂ܂B
\
\    str  ISO8601`Ȃǂŕ\ꂽ\镶
=end =============
# defined in when/format.rb

=begin ***********
#--- Calendar.strptime(str [, fmt=%c])
\  str ŗ^ꂽAfmt̏ɏ]ĕ\ꂽ\镶͂āA
\  ͌ʂnbVŕԂ܂B
\
\    str  \镶
\    fmt  str ]Ă鏑
=end =============
# defined in when/format.rb

=begin ***********
#--- Calendar.new([quality={}])
\  Calendar+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`
=end =============
  def initialize(quality={})
    raise TypeError, 'Pure virtual class: <Calendar>'
#   _copy_quality(quality)
#   _qualify
  end

=begin #########################################################
\==pubN CX^X \bh:                           #
$==Public Instance Method:                                     #
=end ###########################################################
  public

=begin ***********
#--- Calendar#month_name(id)
#--- Calendar#day_name(id)
#--- Calendar#month_name_abbr(id)
#--- Calendar#day_name_abbr(id)
\  id ̖O,j̖Oт̏ȗ`ɕϊĕԂ܂B
\
\    id  ̏ꍇ͌̏܂͔z[,[]
\        j̏ꍇ͐l(0:j, .., 6:yj)
=end =============
  def month_name(id) @MonthNames[id][0] end
  def month_name_abbr(id) month_name(id).sub('^(...?).*$', '\1') end
  def day_name(id) @DayNames[id] end
  def day_name_abbr(id) day_name(id).sub('^(...?).*$', '\1') end

=begin ***********
#--- Calendar#all_month_names
\  ̖Oׂ'|'ŌԂ܂B
=end =============
  def all_month_names() @AllMonthNames end

=begin ***********
#--- Calendar#all_day_names
\  j̖Oׂ'|'ŌԂ܂B
=end =============
  def all_day_names() @AllDayNames end

=begin ***********
#--- Calendar#month_id(name)
\  ̖O܂͂̏ȗ` id ɕϊĕԂ܂B
\  [̂Ȃ@̏ꍇ id ͌̏A
\  [̂@̏ꍇ id ͔z[,[EE]łB
\
\    name ̖O܂͂̏ȗ`
\        ( name  id ^ƁA id ̂܂ܕԂ܂)
=end =============
  def month_id(name)
    return name unless String === name
    @MonthNames.each do |key, value|
      return key if name == key
      return nil if name.length < 3
      value.each do |mon|
        return key if mon =~ /^#{name}/i
      end
    end
    return nil
  end

=begin ***********
#--- Calendar#day_id(name)
\  j̖O܂͂̏ȗ` id ɕϊĕԂ܂B
\
\    name j̖O܂͂̏ȗ`
\        ( name  id ^ƁA id ̂܂ܕԂ܂)
=end =============
  def day_id(name)
    return name if Numeric === name
    name = name.downcase
    @DayNames.length.times do |id|
      return id if name == day_name_abbr(id).downcase
      return id if name == day_name(id).downcase
    end
    return nil
  end

=begin ***********
#--- Calendar#exist?(*date)
\  \ɑΉt݂Ă΁A̒nʓԂ܂B
\  \ɑΉt݂ĂȂ΁Anil Ԃ܂B
\
\    date t\i[z
=end =============
  def exist?(*date)

    yseq  = _yseq_range(date[0])
    dseq  = _dseq_range(date[2])

    d     = [_normalize_year(date[0])]
    d[1]  = month_id(date[1])       if date[1]
    d[2], = _normalize_day(date[2]) if date[2]
    d    += date[3..-1]             if date[3]

    yseq.each do |ys|
      dseq.each do |ds|
        d0 = d.dup
        d0[0] += ys

        sdn  = _date_to_sdn(*d0[0..2])
        next unless sdn
        sdn += ds
        sd   = d0[3] ? _time_to_sd(sdn, *d0[3..-1]) : sdn
        next unless sd

        d0[0]  = _denormalize_year(d0[0], ys)
        d0[2]  = _denormalize_day (d0[2], ds ) if Numeric===d0[2] && d0[2]>=0
        d1     = sd_to_date(sd)

        return sd if _compare_dates(d0, d1)
      end
    end
    return nil
  end

=begin ***********
#--- Calendar#date_to_sd(*date)
\  \znʓɕϊĕԂ܂B
\
\    date \z  N [, [, [, [, [,b [,b̏]]]]]]
=end =============
  def date_to_sd(*date)
    a    = [_normalize_year(date[0])]
    a[1] = month_id(date[1]) if date[1]
    a[2], dseq = _normalize_day(date[2]) if date[2]
    sdn = _date_to_sdn(*a)
    return nil unless sdn
    sdn += (dseq||0)
    return sdn unless date[3]
    _time_to_sd(sdn, *date[3..-1])
  end

=begin ***********
#--- Calendar#sd_to_date(sd [, n=1 [, off=[0,1]]])
\  nʓ\\̑gɕϊĕԂ܂B
\
\    sd  nʓ
\    n   n Ԗڂ̓\\̑gɕϊ邩w
\    off IN@̕␳([I[,])
=end =============
  def sd_to_date(sd, n=1, off=[0,1])
    return 1   if  n==false
    return nil if  Numeric === n && n != 1
    off = [off,0] unless Array === off

    sdn = round_day(sd)
    date = _sdn_to_date(sdn) + _sd_to_time(sd)

    date = _denormalize_year(date[0], sdn, off),  date[1], 
           _denormalize_day(date[2], _day_offset(sd)), *date[3..-1]

    return (n==1) ? date : [date]
  end

=begin ***********
#--- Calendar#sd_to_s(sd [, n=1 [, off=[0,1]]])
\  nʓISO8601gɕϊĕԂ܂B
\
\    sd  nʓ
\    n   n Ԗڂ̓\\̑gɕϊ邩w
\    off IN@̕␳([I[,])
=end =============
  def sd_to_s(sd, n=1, off=[0,1])
    return 1   if  n==false
    return nil if  Numeric === n && !(n == 1)
    off = [off,1] unless Array === off

    f = @Format.dup
    date = sd_to_date(sd, 1, off).collect {|s|
      fmt = f.shift
      case s
      when Array;  format(fmt[1], s[0], fmt[2][s[1]])
      when Numeric; format(fmt[0],
              (s * (f.length == 0 ? @TimeUnits[-1][0] : 1)).to_i)
      else raise TypeError, 'Terms should be Array or Numeric'
      end
    }.join('')

    return (n==1) ? date : [date]
  end

=begin ***********
#--- Calendar#new_year(year)
\  ^p̔N̎n߂̒nߒʓԂ܂B
\
\    year @ASY^N̏
=end =============
  def new_year(year)
    return _date_to_sdn(year) unless @YearBorder
    _date_to_sdn(year-@YearBorder['Offset'], *@YearBorder['Date'])
  end

=begin ***********
#--- Calendar#new_day(sdn)
\  ^p̓̎n߂̒nʓԂ܂B
\
\    sdn  nߒʓ
=end =============
  def new_day(sdn)
    return _time_to_sd(sdn) unless @DayBorder
    _time_to_sd(sdn-@DayBorder['Offset'], *@DayBorder['Time'])
  end

=begin ***********
#--- Calendar#round_day(sd)
\  nʓ𓖊Y@ł̓̒nߒʓɊۂ߂ĕԂ܂B
\
\    sd  nʓ
=end =============
  def round_day(sd)
    (sd + 1.to_r/2).floor - _day_offset(sd)
  end

=begin ***********
#--- Calendar#shift_sd(sd, period)
\  sd  period Ŏw肳ꂽԂunʓԂ܂B
\
\    period ISO8601ԕ 
=end =============
  def shift_sd(sd, period)
    unless period =~ /^\/*P?\d*Y?\d*M?\d*W?\d*D?(T\d*H?\d*M?\d*S?)?\/*$/
      raise ArgumentError, 'invalid period format'
    end
    period =~ /(\/*)$/
    sign = ($1.length % 2) == 0 ? +1 : -1
    time = false
    period.upcase.scan(/(\d*)([YMWDTHMS])/) do |term|
      n  = term[0].to_i
      n  = 1 if n == 0
      n *= sign
      case term[1]
      when 'Y'; sd = shift_sd_y(sd, n)
      when 'D'; sd += n
      when 'W'; sd += 7 * n
      when 'T'; time = true
      when 'H'; sd += n.to_r / @TimeUnits[2][0]
      when 'S'; sd += n.to_r /
         (@TimeUnits[2] * @TimeUnits[3][0] * @TimeUnits[4][0])
      when 'M'
        if time 
          sd += n.to_r / (@TimeUnits[2][0] * @TimeUnits[3][0])
        else
          sd = shift_sd_m(sd, n)
        end
      end
    end
    return sd
  end

=begin ***********
#--- Calendar#shift_sd_y(sd, n)
\  sd Ŏw肵 n N̒nʓԂ܂B
\
\    sd  nʓ 
\    n   N 
=end =============
  def shift_sd_y(sd, n)
    date    = sd_to_date(sd)
    year    = _normalize_year(date[0])
    date[0] = _denormalize_year(year + n, round_day(sd), [0,1])
    date_to_sd(*date)
  end

=begin ***********
#--- Calendar#shift_sd_m(sd, n)
\  sd Ŏw肵 n ̒nʓԂ܂B
\
\    sd  nʓ 
\    n    
=end =============
  def shift_sd_m(sd, n)
    date = sd_to_date(sd)
    if    Integer === @TimeUnits[0][0] && # constant months in year
          Integer === date[0] && Integer === date[1]
      r, date[0] = (date[0] * @TimeUnits[0][0] + 
                    date[1] - @TimeUnits[0][1] + n).
                    moddiv(   @TimeUnits[0][0])
      date[1] = r + @TimeUnits[0][1]
      return date_to_sd(*date)

    elsif Integer === @TimeUnits[1][0] # constant days in month
      return sd + n * @TimeUnits[1][0]
    end

    sd += (@MeanMonth * n).floor
    step = date[2..-1] <=> sd_to_date(sd)[2..-1]
    sign = step
    until sign == 0
      sd += step
      sign = date[2..-1] <=> sd_to_date(sd)[2..-1]
      return nil if sign * step < 0
    end
    return sd
  end

=begin ***********
#--- Calendar#internal_timezone
\  @gpĂ^C][Ԃ܂B
\  Date::Extended+IuWFNgێ鎞Ƃ͕ʕłB
\  Ⴆ΁A{ł͒Ԓł̎̂܂ܗpĐ閾̌vZ
\  sĂ܂B
=end =============
  def internal_timezone()
    return  @Timezone[0] if Array === @Timezone
    return (@Timezone || 0)
  end

=begin #########################################################
\==veNebh CX^X \bh:                       #
$==Prptected Instance Method:                                  #
=end ###########################################################
  protected

=begin ***********
#--- Calendar#_date_to_sdn(*date)
\  NEEnߒʓɕϊĕԂ܂B
\  TuNXōĒ`ĂB
\
\    date \z  N [, [,]]
=end =============
# This method should be defined in each sub class.
  def _date_to_sdn(*date) end

=begin ***********
#--- Calendar#_time_to_sd(sdn, *time)
\  ̕\߂AnʓɕϊĕԂ܂B
\  xςꍇ̓TuNXōĒ`ĂB
\
\    sdn  vZ̒nߒʓ
\    time ̕\^z
=end =============
  def _time_to_sd(sdn, *time)
    len  = @TimeUnits.length - 3
    df   = time[len] || 0
    df   = df.to_r if Float === df
    time = time[0..len-1]
    fact = @TimeUnits[2..time.length+1].reverse
    time[0..len-1].reverse_each do |t|
      df = (df + (t.to_r-fact.first[1]))/ fact.first[0]
      fact.shift
    end
    sdn + df - 1.to_r/2
  end

=begin ***********
#--- Calendar#_sdn_to_date(sdn)
\  nߒʓNEEɕϊĕԂ܂B
\  TuNXōĒ`ĂB
\
\    sdn nߒʓ
=end =============
# This method should be defined in each sub class.
  def _sdn_to_date(sdn) end

=begin ***********
#--- Calendar#_sd_to_time(sd)
\  nʓ̕\̑gɕϊĕԂ܂B
\  xςꍇ̓TuNXōĒ`ĂB
\
\    sd nʓ
=end =============
  def _sd_to_time(sd)
    time, fact, df = [], 0, (sd+1.to_r/2).modulo(1)
    @TimeUnits[2..-2].each do |fact|
      df *= fact[0]
      df, count = df.moddiv(1)
      time << count + fact[1]
    end
    time << df
    return *time
  end

=begin ***********
#--- Calendar#_m_in_y(*date)
\  w肵NɊ܂܂錎̐Ԃ܂B
\  (^p\̔N͍l܂)
\
\    date \z 
=end =============
  def _m_in_y(*date)
    return @TimeUnits[0][0].to_i if Numeric === @TimeUnits[0][0]

    sd0 = _date_to_sdn(_normalize_year(date[0]),
                    @TimeUnits[0][1], @TimeUnits[1][1])
    return nil unless sd0
    sd2 = _shift_y_sd(sd0, 1)
    m   = ((sd2-sd0) / @Config['MeanMonth']).to_i
    sd1 = shift_sd_m(sd0, m)
    m + (sd2 <=> sd1)
  end

=begin ***********
#--- Calendar#_d_in_y(*date)
\  w肵NɊ܂܂̐Ԃ܂B
\  (^p\̔N͍l܂)
\
\    date \z 
=end =============
  def _d_in_y(*date)
    sd0 = _date_to_sdn(_normalize_year(date[0]),
            @TimeUnits[0][1], @TimeUnits[1][1])
    return nil unless sd0
    sd2 = shift_sd_y(sd0, 1)
    sd2 - sd0
  end

=begin ***********
#--- Calendar#_d_in_m(*date)
\  w肵Ɋ܂܂̐Ԃ܂B
\
\    date \z 
=end =============
  def _d_in_m(*date)
    sd0 = _date_to_sdn(_normalize_year(date[0]), month_id(date[1]),
                                                 @TimeUnits[1][1])
    return nil unless sd0
    sd2 = shift_sd_m(sd0, 1)
    sd2 - sd0
  end

=begin ***********
#--- Calendar#_matched_list(key, all)
\  key ɈvꍇAzŕԂ܂B
\  key  false ̏ꍇ́Av̂Ƃ܂B
\
\    key  L[
\    all  Eras+ Ƃ̌݊̂߂ɗpӂĂ܂B Eras+ȊOł͎g܂B
=end =============
  def _matched_list(key, all)
    return [[self]] unless key
    _title.each do |title|
      return [[self]] if key =~ /#{title}/i
    end
    return [[self]] if month_id(key)
    return []
  end
  public :_matched_list # for Calendar.get

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- Calendar#_compare_dates(d0, d1)
\  z d0, d1 ̓rvĂ(true)(false)Ԃ܂B
\
\    d0, d1 i[z
=end =============
  def _compare_dates(d0, d1)
    (0..d0.length-1).each do |i|
      if i > 0 && Numeric === d0[i] && d0[i] < 0
        len = @TimeUnits[i-1][0]
        len = len.call(d0) if Proc === len
        return false unless Array === d1[i] ||
                             d1[i] == d0[i] + len + @TimeUnits[i-1][1]
      else
        unless (1..2) === i && Numeric === d0[i] && Array === d1[i]
          return false unless d1[i] == d0[i]
        end
      end
    end
    return true
  end

=begin ***********
|--- Calendar#_dseq_range(day)
|  \̂␳l dseq ̒lzŕԂ܂B
|
|    day  i[z܂͐
=end =============
  def _dseq_range(day)
    return [0]
  end

=begin ***********
|--- Calendar#_normalize_day(dd)
|  ̕\@ASY鐮̑gɕϊĕԂ܂B
|  g̑1vf - ̒ʎZ
|  g̑2vf - ␳l(Ⴆ΁A[n܂@ŌߑO0OȂ-1)
|
|    dd ̕\((Numeric*), z(Array*)))
=end =============
  def _normalize_day(dd)
    case dd
    when Numeric; return dd.to_i, 0
    when Array;   return *dd
    else;         raise TypeError, 'invalid day type'
    end
  end
  
=begin ***********
|--- Calendar#_denormalize_day(day, dseq)
|  @ASY^鐮̑g̕\ɕϊĕԂ܂B
|
|    day  ̒ʎZ
|    dseq ␳l(_~[)
=end =============
  def _denormalize_day(day, dseq)
    return day
  end

=begin ***********
|--- Calendar#_day_offset(sd)
|  ^p̓̋؂l̏̕␳lԂ܂B
|
|    sd nʓ(_~[)
=end =============
  def _day_offset(sd)
    return 0
  end

=begin ***********
|--- Calendar#_yseq_range(year)
|  \̂N␳l yseq ̒lzŕԂ܂B
|
|    year  Ni[z܂͐
=end =============
  def _yseq_range(year)
    return [0]
  end

=begin ***********
|--- Calendar#_normalize_year(yy)
|  N̕\@ASY鐮ɕϊĕԂ܂B
|
|    yy N̕\((Numeric*), z(Array*))
=end =============
  def _normalize_year(yy)
    case yy
    when Numeric
      return yy.to_i
    when Array
      if Array === yy[-1] 
        yy[-1], yseq, = yy[-1]
      elsif yy.length == 2 && @YearBorder && !@YearUnits
        yy, yseq  = yy
      else
        yseq = 0
      end
      return _normalize_year_units(yy) + yseq
    else
      raise ArgumentError, 'invalid year type'
    end
  end
  public :_normalize_year # for Calendar.select

=begin ***********
|--- Calendar#_denormalize_year(year, day [, off=nil])
|  @ASY^鐮N̕\ɕϊĕԂ܂B
|
|    year @ASY^N̏
|    day ␳ľɎgp(nߒʓ ܂ ς݂̕␳l)
|    off IN@̕␳([I,]) 
=end =============
  def _denormalize_year(year, day, off=nil)
    return _denormalize_year_units(off ? (year-off[0]) / off[1] : year-day)
  end

=begin ***********
|--- Calendar#_denormalize_year_units(year)
|  ŕ\ꂽNzɓWJ܂(_~[)B
|
|    year  N\
=end =============
  def _denormalize_year_units(year)
    return  year
  end

=begin ***********
|--- Calendar#_normalize_year_units(y)
|  zŕ\ꂽN𐮐ɐK܂B
|
|    y  N\z܂͐
=end =============
  def _normalize_year_units(y)
    return [*y][-1].to_i
  end

=begin ***********
#--- Calendar#_qualify
\  Calendar+IuWFNg̐`ݒ肵܂B
\  TuNXōĒ`Ă(Ē`̍ۂ͕KŌ super
\  Ăł)B
\
\  @Title      = self ̃^Cg
\  @MonthNames = ̖O̒`
\  @LeapNames  = [̖@
\  @MeanMonth  = 1̕ϓ
\  @DayNames   = j̖O̒`
\  @TimeUnits  = N̒Pʂ̒`
\  @Format     = Nbb̏̏
\  @DayBorder  = ̎n߂̒`
\  @YearBorder = N̎n߂̒`
\  @YearUnits  = Nȏ̒Pʂ̒`
=end =============
  def _qualify
    @MonthNames ||= Date::MONTHNAMES[1..12]
    @DayNames   ||= Date::DAYNAMES

    @TimeUnits  ||= [nil, nil, 24, 60, 60, 100]

    @Format     ||= [["%4d-", "%4d%c", "-=*"      ], 
                     ["%02d-","%02d%c","-<=>!%&*+"],
                     ["%02dT","%02d%c","-=*"      ], 
                     ["%02d:","%02d%c","-=*"      ],
                     ["%02d:","%02d%c","-=*"      ],
                     ["%02d", "%02d%c","-=*"      ],
                     [".%02d",".%02d", "-=*"      ]]

    @MeanMonth  ||= 30

    case @MonthNames
    when Array
      hash = {}
      @MonthNames.each_index do |i|
        if @LeapNames
          @LeapNames.each do |k|
            hash[[i+1,k[0]]] = [k[1] % @MonthNames[i]] if !k[2] || k[2] == i+1
          end
        else
          hash[i+1] = [@MonthNames[i]]
        end
      end
      @MonthNames = hash
    when Hash
      @MonthNames.each_key do |key|
        @MonthNames[key] = [*@MonthNames[key]]
      end
    end
    a = []
    @MonthNames.each_value {|m| a += m}
    @AllMonthNames ||= a.join('|')

    @AllDayNames ||= @DayNames.join('|')
    Residue.default_keys(@DayNames, 6)

    @TimeUnits.each_index do |i|
      value = @TimeUnits[i]
      @TimeUnits[i] = [value, (i>1 ? 0 : 1)] unless Array === value
    end

    @TimeUnits[0][0] ||= 
                 (@Months_in_Year || proc{|date| _m_in_y(date[0])})
    @TimeUnits[1][0] ||= 
                 (@Days_in_Month  || proc{|date| _d_in_m(*date[0..1])}) 

    if @DayBorder
      class << self; include DayBorder end
      _qualify_day_border
    end

    if @YearBorder
      class << self; include YearBorder end
      _qualify_year_border
    end

    if @YearUnits
      class << self; include YearUnits end
      _qualify_year_units
    end

    if @Title
      @Title = [*@Title]
      @@outfit['Objs'].push(self)
    end
  # super
  end

=begin #########################################################
|==tŎgp郂W[:                             #
|==Conditional Applied Module:                                 #
|=== DayBorder  ̋EߑO0łȂƂgp                #
|=== YearBorder N̋E11łȂƂgp                 #
|=== YearUnits  Nȏ̊Kw\ƂɎgp           #
=end ###########################################################

=begin ---------------------------------------------------------
|=== DayBorder  ̋EߑO0łȂƂgp                #
=end -----------------------------------------------------------
  module DayBorder
    private

=begin ***********
|--- DayBorder#_qualify_day_border
|  ̋E\nbV܂B
|
|*CX^Xϐ
|   @DayBorder  ̋E\nbV
=end =============
    def _qualify_day_border
      b = @DayBorder
      @DayBorder = {'Time'=>[*b]} unless Hash === b
      @DayBorder['Offset'] ||= (@DayBorder['Time'][0]> 12) ? -1 : 0
    end

=begin ***********
|--- DayBorder#_dseq_range(day)
|  \̂␳l dseq ̒lzŕԂ܂B
|
|    day  i[z܂͐
=end =============
    def _dseq_range(day)
      if Numeric === day && day < 0
        raise ArgumentError, 
          'When day border is valid, day number cannot be nagative'
      end
      return [0] unless day
      return [day[1]] if Array === day
      d = @DayBorder['Offset']
      return [d, d+1, d+2]
    end

=begin ***********
|--- DayBorder#_denormalize_day(day, dseq)
|  @ASY^鐮̑g̕\ɕϊĕԂ܂B
|
|    day  ̒ʎZ
|    dseq ␳l(Ⴆ΁A[n܂@ŌߑO0OȂ-1)
=end =============
    def _denormalize_day(day, dseq)
      return [day, dseq]
    end

=begin ***********
|--- DayBorder#_day_offset(sd)
|  ^p̓̋؂l̏̕␳lԂ܂B
|
|    sd nʓ
=end =============
    def _day_offset(sd)
      dseq  = @DayBorder['Offset']
      sd0   = new_day((sd + dseq + 1.to_r/2).floor)
      dseq += 1 if (sd < sd0)
      return dseq
    end
  end

=begin ---------------------------------------------------------
|=== YearBorder N̋E11łȂƂgp                 #
=end -----------------------------------------------------------
  module YearBorder
    private

=begin ***********
|--- YearBorder#_qualify_year_border
|  N̋E\nbV܂B
|
|*CX^Xϐ
|   @YearBorder  N̋E\nbV
=end =============
    def _qualify_year_border
      b = @YearBorder
      @YearBorder = {'Date'=>[*b]} unless Hash === b
      @YearBorder['Offset'] ||= (@YearBorder['Date'][0]> 6) ? -1 : 0
    end

=begin ***********
|--- YearBorder#_yseq_range(year)
|  \̂N␳l yseq ̒lzŕԂ܂B
|
|    year  Ni[z܂͐
=end =============
    def _yseq_range(year)
      if Array === year
        return [year[-1][1]] if Array === year[-1] 
        return [year[1]]     if year.length == 2 && ! @YearUnits
      end
      return [@YearBorder['Offset'],
              @YearBorder['Offset'] + 1]
      y = @YearBorder['Offset']
      return [y, y+1, y+2]
    end

=begin ***********
|--- YearBorder#_drenormalize_year(year, day [, off=nil])
|  @ASY^鐮N̕\ɕϊĕԂ܂B
|
|    year @ASY^N̏
|    day ␳ľɎgp(nߒʓ ܂ ς݂̕␳l)
|    off IN@̕␳([I,]) 
=end =============
    def _denormalize_year(year, day, off=nil)

      if off
        yseq  = @YearBorder['Offset']
        sd0   = new_year(year + yseq)
        yseq += 1 if (day < sd0)
        year -= yseq
        year = (year - off[0]) / off[1]
      else
        yseq  = day
        year -= yseq
      end

      year = _denormalize_year_units(year)
      unless @YearUnits
        return [year, yseq]
      else
        year[-1] = [year[-1], yseq]
        return year
      end
    end
  end

=begin ---------------------------------------------------------
|=== YearUnits  Nȏ̊Kw\ƂɎgp           #
=end -----------------------------------------------------------
  module YearUnits
    private

=begin ***********
|--- YearUnits#_qualify_year_units
|  N̒Pʂ\z܂B
|
|*CX^Xϐ
|   @YearUnits  N̒Pʂ\z
=end =============
    def _qualify_year_units
      @YearUnits.each_with_index do |item, index|
        @YearUnits[index] = [item, 0] unless Array === item
      end
    end

=begin ***********
|--- YearUnits#_normalize_year_units(y)
|  zŕ\ꂽN𐮐ɐK܂B
|
|    y  N\z܂͐
=end =============
    def _normalize_year_units(y)
      y = [y] unless Array === y
      year, unit = 0, 1
      fact = @YearUnits.reverse
      y.reverse[0..-2].each do |c|
        offset = (c >= 0) ? (c - fact.first[1]) : (fact.first[0] + c)
      # return nil unless (0...fact.first[0]) === offset
        year += unit * offset
        unit *= (fact.length>1) ? fact.shift[0] : fact.first[0]
      end
      return year + unit * (y[0]-fact.first[1])
    end

=begin ***********
|--- YearUnits#_denormalize_year_units(year)
|  ŕ\ꂽNzɓWJ܂B
|
|    year  N\
=end =============
    def _denormalize_year_units(year)
      y = []
      @YearUnit.reverse_each do |fact|
        rem, year = year.moddiv(fact[0])
        y << rem + fact[1]
      end
      return  [year] + y
    end
  end
################################################################

  func :day_name_abbr, :month_name_abbr, :day_id, :month_id
  func :date_to_sd #, :_time_to_sd
# func :sd_to_date, sd_to_s #, :_sd_to_time
  func :_m_in_y, :_d_in_y, :_d_in_m
  func :shift_sd, :new_year #, :new_day, :round_day
end

=begin #########################################################
\==f[^\:                                                 #
$==Data structure:                                             #
=end ###########################################################

=begin -----------
\=== @Title : ^Cg
\  Array [L[, ...., L[]
\
\    Calendar.get ŕ񂩂 self 邽߂̃L[ێ܂B
=end -------------

=begin -----------
\=== @MonthNames : ̖O
\  Hash {ID => [L[, ...., L[], ,,,. }
\
\    IDƌ̖ȎΉ\ێ܂B
\    ID͉[┒Ê@̏ꍇ͔zAȂ@̏ꍇ
\    ̒ʂԍӖ鐮łB
=end -------------

=begin -----------
\=== @LeapNames : [┒Ê@ł̖̌Ȍ
\   Array [[[┒Ȅڍ׏ԍ,  (, Kp錎̔ԍ)], ..]
\     @MonthNames͉[┒Ê@ł͕GɂȂ܂B
\     @MonthNames 邽߂@LeapNames gp܂B
\     {͎sɂ͕svƂȂ܂B
=end -------------

=begin -----------
\=== @AllMonthNames : ׂĂ̖̌O'|'ŋ؂ĂȂ
\   String '̖O|@... |̖O'
\     parse, strptime ̖OF邽߂Ɏgp܂BB
=end -------------

=begin -----------
\=== @MeanMonth : @1Ɋ܂܂镽ς̓
\   Rational
\     Pʂł̓t̉sۂɁA1Ň1̓̂ǂ
\     肹ATuNXł荂̃ASY`Ă
\     ꍇA{pĒᑬASYŌPʂ̉Zs
\     ܂B
=end -------------

=begin -----------
\=== @DayNames : j̖̓O
\  Array [, , , , , , yj̖O\]
\
\    j̔ԍ(0.,,7)Ǝj̖̓ȎΉ\ێ܂B
\    {pāAjɂ킹t肷邽߂Residue+
\    IuWFNg('1st Sunday'ȂǂŌ)𐶐܂B
=end -------------

=begin -----------
\=== @AllDayNames : ׂĂ̖̓O'|'ŋ؂ĂȂ
\   String '̖O|@... |̖O'
\     parse, strptime ̖OF邽߂Ɏgp܂BB
=end -------------

=begin -----------
\=== @TimeUnits : ȉ̌̒Pʏ
\   Array [[Ň,̒l], [̓,̒l], ...]
\    ȉ̌̒Pʏێ܂B
\    Ⴆ΁A[[12,1], [nil,1], [24,0], [60,0], [60,0], [1000000,0]]́A
\      1Ň12()ŁA  1n܂B
\      1͕̓sŁA      1n܂B
\      1̎24()ŁA  0n܂B
\      ....
\    ƂƂ܂B̏ꍇA1͕̓sȂ̂ŁA\bh
\    _d_in_m ŐvZ邱ƂɂȂ܂B
=end -------------

=begin -----------
\=== @Format: ISO8601gp
\   Array [[̏ꍇ̏, z̏ꍇ̏, %cɗ^镶w], ..]
\    ISO8601gpێ܂B
\    Ō̗vf@TimeUnits ̍Ō̌𕶎񉻂邽߂ɍsZ̏łB
=end -------------

=begin -----------
\=== @DayBorder (Calendar::DayBorder include ) : ̋E̒`
\   Hash {'Offset'=>0 or -1, 'Time'=>[, , b, b̏] }
\    ̋EߑO0łȂꍇA̋E`܂B
\    Offset  0 ̏ꍇ͋EߑO0A-1̏ꍇ͑Oɂ܂B
\    ȄꍇA̎ Time Ŏw肵܂BTuNX new_day
\    (̏oA̓莞Ȃǂ)Ē`ĂꍇATime ͎QƂ
\    ܂B
=end -------------

=begin -----------
\=== @YearBorder (Calendar::YearBorder include ) : N̋E̒`
\   Hash {'Offset'=>0 or -1, 'Date'=>[, ] }
\    N̋E11łȂꍇA̋E`܂B
\    Offset  0 ̏ꍇ͋E11A-1̏ꍇ͑Oɂ܂B
\    ȄꍇA̓t Date Ŏw肵܂BTuNX new_year
\    (ՂȂǂ)Ē`ĂꍇADate ͎QƂ܂B
=end -------------

=begin -----------
\=== @YearUnits (Calendar::YearUnits include ) : Nȏ̌̒Pʏ
\   Array [..., [Pʓ̔N,ŏ̔N̒l]]
\    Nȏ̌̒Pʏێ܂B
\   Ⴆ΁A [[20,0], [20,0]]́A}vZ@̏ꍇ̒`ŁA
\      vf 0 - oNgD 20 JgDȂAŏ̃JgD 0
\      vf 1 - JgD 20 gD(= N)ȂAŏ̃gD 0
\    ƂƂ܂B
=end -------------
