# chinab.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#   CCC  H   H I N   N   A   BBBB 
#  C   C H   H I NN  N  A A  B   B
#  C     HHHHH I N N N A   A BBBB 
#  C   C H   H I N  NN AAAAA B   B
#   CCC  H   H I N   N A   A BBBB 
#
=begin #########################################################
#=ChinaB                                                       #
\===Az(ĈȂ[Ƃ)                 #
\ Az(񕽋CA񕽋C@)vZ܂B         #
\                                                              #
\==X[p[NX:                                             #
$==Super Class:                                                #
#*EMD+                                                         #
=end ###########################################################

class ChinaB < EMD

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################

=begin ***********
#--- ChinaB.new([quality={})
\  ChinaB+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
=end =============
  def initialize(quality={})
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==veNebh CX^X \bh:                       #
$==Prptected Instance Method:                                  #
=end ###########################################################
  protected

=begin ***********
#--- ChinaB#_date_to_sdn(yy [, mm=1 or 0 [, dd=1 or 0]])
\  NEEnߒʓɕϊĕԂ܂B
\
\    yy  N
\    mm   (ftHgl͍ŏ̌̔ԍ)
\    dd   (ftHgl͍ŏ̓̔ԍ)
=end =============
  def _date_to_sdn(yy, mm=@TimeUnits[0][1], dd=@TimeUnits[1][1])
    mm = [mm,0] unless Array === mm
    sdn = 1461 * (yy + @YearEpoch + 4712) / 4 + 59 * mm[0] / 2 + dd - 30
    10.times do |i|
      y1, m1, d1 = _sdn_to_date(sdn)
      dm = mm[0] - m1[0]
      if    yy != y1
        sdn += 1461 * (yy - y1) / 4
      elsif mm != m1
        dm += 1 if dm >= 0 && mm[1] > 0
        dm -= 1 if dm == 0 && m1[1] > 0
      else
        return sdn - d1 + dd
      end
      sdn += 59 * dm / 2 + 15 - d1
    end
    return nil
  end

=begin ***********
#--- ChinaB#_sdn_to_date(sdn)
\  nߒʓNEEɕϊĕԂ܂B
\
\    sdn nߒʓ
=end =============
  def _sdn_to_date(sdn)
    # Month parameters
    # 0:month number, 1:day of month-1, 2:days in month
    lunar = Residue.mod(sdn) {|n| _new_month(n)}

    # New moon day
    nMoon = sdn - lunar[1]

    # Solar epoch just before the last day of month
    # 0:month number, 1:days from epoch to the last day of month
    solar = Residue.mod(nMoon + lunar[2] - 1) {|e| _new_epoch(e)}

    # judge leap or not, and adjust solar month number if neccesary
    f = _leap?(lunar[0], solar) # in subclasses, 'solar' may be changed

    y    = solar[0].moddiv(12)
    m    = [y[0] + @TimeUnits[0][1], 0]
    m[1] = 2 if f
    return y[1] - @YearEpoch, m, lunar[1] + @TimeUnits[1][1]
  end

=begin ***********
#--- ChinaB#_new_month(m)
\  m Ŏw肵̎n߂̒nߒʓԂ܂B
\
\    m  ԍ
=end =============
  def _new_month(m)
    t = @Ephemeris[1].cn_to_time(m)
    return (t + 0.5 + @Timezone[0] + @Timezone[1]).floor
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- ChinaB#_leap?(m [, s=nil])
\  w̌[肵܂B
\
\    m  ̒ʂԍ
\    s  {NXł̓_~[
=end =============
  def _leap?(m, s=nil)
    e = _new_month(m+1) - 1
    d = Residue.mod(e) {|n| _new_epoch(n)}
    return (e - d[1] < _new_month(m))
  end

=begin ***********
#--- ChinaB#_qualify
\  ChinaB+IuWFNg̐`ݒ肵܂B
\
\  @CycleOffset   = J̏ꍇ -1
\  @Ephemeris[1]  = ʑ̌vZɗp錎 Ephemeris
\  @Timezone[1]   = i
=end =============
  def _qualify

    @Title       ||= 'ChinaB'
    @CycleOffset ||= -1
    @Ephemeris   ||= ['12S', '1L']
    @Timezone    ||= [Timezone.zone.zone * 24, 0]

    super
  end

################################################################
  func :_date_to_sdn, :_sdn_to_date, :_new_month
end

