# civil.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#   CCC  I V   V I L    
#  C   C I V   V I L    
#  C     I V   V I L    
#  C   C I  V V  I L    
#   CCC  I   V   I LLLLL
#
=begin #########################################################
#=Civil                                                        #
\===p@(EXƃOSI)                         #
$===The civil calendar (Julian and Gregorian)                  #
#                                                              #
\==X[p[NX:                                             #
$==Super Class:                                                #
#*Calendar+                                                    #
=end ###########################################################

class Civil < Calendar

=begin #########################################################
\==NX萔:                                                 #
$==Class Constant:                                             #
=end ###########################################################

=begin ***********
\ MINIMUM   = 1794474 #  201-01-01 ̏(1Ň12ۏ؂ꍇ)
\ ITALY     = 2299161 # 1582-10-15 C^Ał̉
\ ENGLAND   = 2361222 # 1752-09-14 CMXуAJOł̉
\ MAXIMUM   = 3182396 # 4001-01-01 ̉(1Ň12ۏ؂ꍇ)
\ JULIAN    = false   # +Infinity  ɃEXp
\ GREGORIAN = true    # -Infinity  ɃOSIp
=end =============
  MINIMUM   = 1794474 #  201-01-01
  ITALY     = 2299161 # 1582-10-15
  ENGLAND   = 2361222 # 1752-09-14
  MAXIMUM   = 3182396 # 4001-01-01
  JULIAN    = false
  GREGORIAN = true

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- Civil.instance(key)
\  ɑΉCX^X𐶐܂B
\
\    key  CX^Xw肷镶
=end =============
    def instance(key)
      case key
      when /^Italy$/i;     Civil.new('Title'=>'Italy')
      when /^Gregorian$/i; Civil.new('Title'=>'Gregorian','Reform_JD'=>true)
      when /^Julian$/i;    Civil.new('Title'=>'Julian',   'Reform_JD'=>false)
      else;                nil
      end
    end

=begin ***********
#--- Civil.gc_to_jdn(y [, m=1 [, d=1]])
\  OSIEXʓɕϊĕԂ܂B
\  (Eɕw肵āAŌォ̏ɑւ@\͂܂)
\
\    y  N
\    m  
\    d  
=end =============
    def gc_to_jdn(y, m=1, d=1)
      m    = m+13     if m < 0
      m, d = m+1, d+1 if d < 0
      y   -= 1 if m<3
      1721119 + 365*y + [0,31,61,92,122,153,184,214,245,275,306,337][m-3] +
            d + (y.to_f/4).floor - (y.to_f/100).floor + (y.to_f/400).floor
    end

=begin ***********
#--- Civil.jdn_to_gc(jdn)
\  EXʓOSIɕϊĕԂ܂B
\
\    jdn EXʓ
=end =============
    def jdn_to_gc(jdn)
      rem,qq  = (jdn.to_i-1721120).moddiv(146097)
      cc,rem  = rem.divmod 36524
      cc,rem  = 3,36524 if cc==4
      ff,rem  = rem.divmod  1461
      yy,rem  = rem.divmod   365
      yy,rem  = 3,365   if yy==4
      mm,rem  = rem.divmod   153
      nn,rem  = rem.divmod    61
      dd,rem  = rem.divmod    31
      y = 400*qq + 100*cc + 4*ff + yy
      m =   5*mm +   2*nn +   dd +  3
      d = rem + 1
      y, m =  y+1, m-12 if mm==2
      return y, m, d
    end

=begin ***********
#--- Civil.jc_to_jdn(y [, m=1 [, d=1]])
\  EXEXʓɕϊĕԂ܂B
\  (Eɕw肵āAŌォ̏ɑւ@\͂܂)
\
\    y  N
\    m  
\    d  
=end =============
    def jc_to_jdn(y,m,d)
      m    = m+13     if m < 0
      m, d = m+1, d+1 if d < 0
      y   -= 1 if m<3
      1721117 + 365*y + [0,31,61,92,122,153,184,214,245,275,306,337][m-3] +
            d + (y.to_f/4).floor
    end

=begin ***********
#--- Civil.jdn_to_jc(jdn)
\  EXʓEXɕϊĕԂ܂B
\
\    jdn EXʓ
=end =============
    def jdn_to_jc(jdn)
      rem,ff  = (jdn.to_i-1721118).moddiv(1461)
      yy,rem  = rem.divmod   365
      yy,rem  = 3,365   if yy==4
      mm,rem  = rem.divmod   153
      nn,rem  = rem.divmod    61
      dd,rem  = rem.divmod    31
      y = 4*ff + yy
      m = 5*mm +  2*nn +  dd + 3
      d = rem + 1
      y, m =  y+1, m-12 if mm==2
      return y, m, d
    end
  end # of class method

=begin ***********
#--- Civil.new([quality=ITALY])
\  Civil+ IuWFNg𐶐ĕԂ܂B
\
\    quality  l(Numeric*)ȂΉ
\             _l(true*) ȂΏɃOSIgp̎w
\             _l(false*)ȂΏɃEXgp̎w
\             nbV(Hash*)Ȃΐ`nbV
\               (: Civil.new('Reform_JD'=>ENGLAND))
=end =============
  def initialize(quality=ITALY)
    case quality
    when Hash;
    when Numeric, true, false; quality = { 'Reform_JD' => quality }
    else; raise ArgumentError, 'invalid option type' 
    end
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==pubN CX^X \bh:                           #
$==Public Instance Method:                                     #
=end ###########################################################
  public

=begin ***********
#--- Civil#easter(year)
\  Ղ̒nߒʓԂ܂B
\  (w̔N320ɎgĂ@ŌvZ܂)
\
\    year N
=end =============
  def easter(year)
    year = year.to_i
    greg = @Reform_JD
    if Integer===@Reform_JD
      greg = (type.gc_to_jdn(year,3,20)>=@Reform_JD)
    end

    p    = @Easter
    h    = greg ? year.moddiv(100)[1] : 0
    c    = -h + h.moddiv(4)[1] + (8*(h+11)).moddiv(25)[1]
    g    = ((year + p['B']) % p['S']) + 1;

    m    = (c + 11 * g + p['C']) % 30
    if p['F'] == 0
      m += 1 if (m==0 || m==1 && g > p['N'])
    else
      m += (g  - 1) / p['F']
      m -= 30 if (m > p['N'])
    end

    ejdn = (greg ? type.gc_to_jdn(year,4,p['D']) : 
                   type.jc_to_jdn(year,4,p['D'])) - m
    ejdn += p['G'] - ((ejdn - p['W']) %  7) if (p['W'] < 7)

    return ejdn
  end

=begin #########################################################
\==veNebh CX^X \bh:                       #
$==Prptected Instance Method:                                  #
=end ###########################################################
  protected

=begin ***********
#--- Civil#_date_to_sdn(y [, m=1 [, d=1]])
\  NEEnߒʓɕϊĕԂ܂B
\
\    y  N
\    m  
\    d  
=end =============
  def _date_to_sdn(y, m=1, d=1)
    case @Reform_JD
    when Integer
      sd = type.gc_to_jdn(y, m, d)
      return sd if sd >= @Reform_JD
      return type.jc_to_jdn(y, m, d)
    when true;  return type.gc_to_jdn(y, m, d)
    when false; return type.jc_to_jdn(y, m, d)
    end
  end

=begin ***********
#--- Civil#_sdn_to_date(sdn)
\  nߒʓNEEɕϊĕԂ܂B
\
\    sdn nߒʓ
=end =============
  def _sdn_to_date(sd)
    case @Reform_JD
    when Integer
      return type.jdn_to_gc(sd) if sd >= @Reform_JD
      return type.jdn_to_jc(sd)
    when true;  return type.jdn_to_gc(sd)
    when false; return type.jdn_to_jc(sd)
    end
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- Civil#_qualify
\  Civil+ IuWFNg̐`ݒ肵܂B
\
\  @Month_in_Year = I1N12Ȃ邱Ƃ܂B
\  @Reform_JD     = EXOSIւ̉
\  @Easter        = Ղ̌vZ@
#                         (1)               # Julian/Gregorian
#                          |    (2)         # Hippolytus
#                          |     |    (3)   # Augustalis(Roman Rule)
#                  { 'W'=> 6,    5,    5,   # day of week adjustment
#                    'G'=> 7,    8,    8,   # guard
#                    'C'=> 0,   10,   16,   # offset
#                    'B'=> 0,    0,   38,   # base
#                    'F'=> 0,    4,   14,   # full moon adjustment
#                    'D'=>19,   14,   13,   # latest day of month
#                    'N'=>11,   30,   29,   # normal year number
#                    'S'=>19     8    84    # period length / year
#                  }
=end =============
  def _qualify
    @Months_in_Year ||= 12
    @Reform_JD        = ITALY if @Reform_JD == nil
    @Easter         ||= { 'W'=> 6,
                          'G'=> 7,
                          'C'=> 0,
                          'B'=> 0,
                          'F'=> 0,
                          'D'=>19,
                          'N'=>11,
                          'S'=>19
                        }

    if Float === @Reform_JD
      case @Reform_JD
      when +Infinity; @Reform_JD = false
      when -Infinity; @Reform_JD = true
      else;           @Reform_JD = @Reform_JD.to_i
      end
    end
    if  (Integer          === @Reform_JD &&
       !(MINIMUM..MAXIMUM === @Reform_JD))
      raise ArgumentError, 'invalid option range' 
    end
    super
  end

################################################################

  func_class_method :gc_to_jdn, :jdn_to_gc, :jc_to_jdn, :jdn_to_jc
  func :_date_to_sdn, :_sdn_to_date
  func :easter
end
