# dmd.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  DDDD  M     M DDDD 
#  D   D MM   MM D   D
#  D   D M M M M D   D
#  D   D M  M  M D   D
#  DDDD  M     M DDDD 
#
=begin #########################################################
#=DMD                                                          #
\===̔z1̎n܂uԂ̕ʂ̗̓tŌ肳    #
\                                                              #
\==X[p[NX:                                             #
$==Super Class:                                                #
#*Calendar+                                                    #
=end ###########################################################

class DMD < Calendar
  class << self

=begin ***********
#--- DMD.instance(key)
\  ɑΉCX^X𐶐܂B
\
\    key  CX^Xw肷镶
=end =============
    def instance(key)
      case key
      when /^IndiaD$/i
        DMD.new(
          'Title'    =>  'IndiaD',
          'Ephemeris'=>  '30L',
          'Timezone' =>  +5.5,
          'DayBorder'=>   6,
          'Calendar' =>  'IndiaB'
        )
      else; nil
      end
    end
  end # of class method

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################

=begin ***********
#--- DMD.new([quality={}])
\  DMD+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
=end =============
  def initialize(quality={})
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==pubN CX^X \bh:                           #
$==Public Instance Method:                                     #
=end ###########################################################
  public

=begin ***********
#--- DMD#date_to_sd(*date)
\  \znʓɕϊĕԂ܂B
\
\    date \z  N [, [, [, [, [,b [,b̏]]]]]]
=end =============
  def date_to_sd(*date)
    id    = [_normalize_year(date[0])]
    id[1] = month_id(date[1]) if date[1]
    id[2], dseq = _normalize_day(date[2]) if date[2]
    return nil unless (sdn = _date_to_sdn(*id))
    sdn  += (dseq||0)
    return sdn unless date[3]
    _time_to_sd(sdn, *date[3..-1])
  end

=begin ***********
#--- DMD#sd_to_date(sd [, n=1 [, off=[0,1]]])
\  nʓ\\̑gɕϊĕԂ܂B
\
\    sd  nʓ
\    n   n Ԗڂ̓\\̑gɕϊ邩w
\    off IN@̕␳([I[,])
=end =============
  def sd_to_date(sd, n=1, off=[0,1])
    return 1   if n==false
    return nil if Numeric === n && n != 1
    sdn   = round_day(sd)
    id    = _sdn_to_date(sdn)
    id[0] = _denormalize_year(id[0], sdn, off)
    id[2][1] += _day_offset(sd)
    id   += _sd_to_time(sd)
    return (n==1) ? id : [id]
  end

=begin #########################################################
\==p pubN CX^X \bh:                  #
$==Public Instance Method for Internal Calendar:               #
=end ###########################################################

=begin ***********
#--- DMD#cal
\  pɎgpĂ@(Calendar+)IuWFNgԂ܂B
\
=end =============
  def cal()  @Calendar end

=begin ***********
#--- DMD#exist_internal?(*date)
\  \ɑΉt݂Ă΁A̒nʓԂ܂B
\  \ɑΉt݂ĂȂ΁Anil Ԃ܂B
\
\    date t\i[z
=end =============
  def exist_internal?(*date)  @Calendar.exist?(*date) end

=begin ***********
#--- DMD#internal_date_to_sd(*date)
\  \znʓɕϊĕԂ܂B
\
\    date \z  N [, [, [, [, [,b [,b̏]]]]]]
=end =============
  def internal_date_to_sd(*date)
    return nil unless (isd = (@Calendar.date_to_sd(*date)))
    isd_to_sd(isd)
  end

=begin ***********
#--- DMD#sd_to_internal_date(sd [, n=1 [, off=[0,1]]])
\  nʓ\\̑gɕϊĕԂ܂B
\
\    sd   nʓ
\    n    n Ԗڂ̓\\̑gɕϊ邩w
\    off  IN@̕␳([I[,])
=end =============
  def sd_to_internal_date(sd, n=1, off=[0,1])
    @Calendar.sd_to_date(sd_to_isd(sd), n, off)
  end

=begin ***********
#--- DMD#sd_to_internal_s(sd [, n=1 [, off=[0,1]]])
\  nʓISO8601gɕϊĕԂ܂B
\
\    sd   nʓ
\    n    n Ԗڂ̓\\̑gɕϊ邩w
\    off  IN@̕␳([I[,])
=end =============
  def sd_to_internal_s(sd, n=1, off=[0,1])
    @Calendar.sd_to_s(sd_to_isd(sd), n, off)
  end

=begin ***********
#--- DMD#internal_new_year(year)
\  ^p̔N̎n߂̒nߒʓԂ܂B
\
\    year ̗@ASY^N̏
=end =============
  def internal_new_year(year) isd_to_sd(@Calendar.new_year(year)) end

=begin ***********
#--- DMD#internal_new_day(sd)
\  ^p̓̎n߂̒nʓԂ܂B
\
\    sd  nʓ
=end =============
  def internal_new_day(sd)
    isd_to_sd(@Calendar.new_day(@Calendar.round_day(sd_to_isd(sd))))
  end

=begin ***********
#--- DMD#internal_round_day(sd)
\  nʓ𓖊Y@ł̓̒nߒʓɊۂ߂ĕԂ܂B
\
\    sd  nʓ
=end =============
  def internal_round_day(isd) isd_to_sd(@Calendar.round_day(sd_to_isd(sd))) end

=begin ***********
#--- DMD#shift_internal_sd(sd, period)
\  sd  period Ŏw肳ꂽԂunʓԂ܂B
\
\    period ISO8601ԕ 
=end =============
  def shift_internal_sd(sd, period)
    isd_to_sd(@Calendar.shift_isd(sd_to_isd(sd), period))
  end

=begin #########################################################
\==veNebh CX^X \bh:                       #
$==Prptected Instance Method:                                  #
=end ###########################################################
  protected

=begin ***********
#--- Calendar#_date_to_sdn(*date)
\  NEEnߒʓɕϊĕԂ܂B
\  TuNXōĒ`ĂB
\
\    date \z  N [, [,]]
=end =============
  def _date_to_sdn(*date)
    return nil unless (is = (@Calendar.date_to_sd(*date)))
    ss = isd_to_sd(@Calendar.new_day(@Calendar.round_day(is)))
    return round_day(ss) + 1
  end

=begin ***********
#--- Calendar#_sdn_to_date(sdn)
\  nߒʓNEEɕϊĕԂ܂B
\  TuNXōĒ`ĂB
\
\    sdn nߒʓ
=end =============
  def _sdn_to_date(sdn)
    id = sd_to_internal_date(new_day(sdn))[0..2]
    is = @Calendar.date_to_sd(*id)
    ss = isd_to_sd(@Calendar.new_day(@Calendar.round_day(is)))
    id[2] = [id[2], sdn - (round_day(ss)+1)]
    return id
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- DMD#sd_to_isd(sd)
\  nʓ@̒nʓɕϊĕԂ܂B
\
\    sd nʓ 
=end =============
  def sd_to_isd(sd)
    @Ephemeris.time_to_cn(sd - internal_timezone) + 
    @Calendar.internal_timezone
  end

=begin ***********
#--- DMD#isd_to_sd(isd)
\  @̒nʓnʓɕϊĕԂ܂B
\
\    isd  @̒nʓ 
=end =============
  def isd_to_sd(isd)
    @Ephemeris.cn_to_time(isd - @Calendar.internal_timezone) + 
    internal_timezone
  end

=begin ***********
#--- DMD#_qualify
\  DMD+IuWFNg̐`ݒ肵܂B
\
\  @Ephemeris       = ԂƏL̎ԂϊEphemeris+IuWFNg
\  @Timezone        = vZɗp^C][(Rational*)
\  @Calendar        = ťƂ@Calendar+IuWFNg
=end =============
  def _qualify

    unless (@Ephemeris = Ephemeris.get(@Ephemeris))
      @Ephemeris = Ephemeris.get('30L')
    end

    @Timezone   /= 24.to_f

    unless (@Calendar = Calendar.get(@Calendar))
      raise ArgumentError, 'invalid calendar'
    end

    @MonthNames    ||= @Calendar['MonthNames']
    @AllMonthNames ||= @Calendar['AllMonthNames']

    super
  end

################################################################
  func :date_to_sd, :sd_to_date, :_date_to_sdn, :_sdn_to_date
  func :sd_to_isd,  :isd_to_sd
end

=begin #########################################################
\==DateNX̃CX^X \bh̒ǉ:                    #
$==Date class' Instance Method:                                #
=end ###########################################################
  class Date

=begin ***********
#--- Date#internal_sd
\  ̒nʓԂ܂B
=end =============
  def internal_sd() @cal.sd_to_isd(sd)  end

=begin ***********
#--- Date#internal_year ([k=1])
#--- Date#internal_month ([k=1])
#--- Date#internal_day ([k=1])
#--- Date#internal_hour ([k=1])
#--- Date#internal_minute ([k=1])
#--- Date#internal_second ([k=1])
#--- Date#internal_usec ([k=1])

#--- Date#internal_mon ([k=1])
#--- Date#internal_mday ([k=1])
#--- Date#internal_min ([k=1])
#--- Date#internal_sec ([k=1])
\  ꂼANEE(*)EEEbEb̏, E(*)EEbԂ܂B
\  (* ͌̒ʎZ(1 ܂ 0`̓))
\
\    k  L k Ԗڂ̓t\ɑΉlԂ悤w܂B
\      (@Ƃ Eras+IuWFNggpĂꍇ)
=end =============
  def internal_year(k=1)   show_all_internal_date(k, 0) end
  def internal_month(k=1)  show_all_internal_date(k, 1) end
  def internal_day(k=1)    show_all_internal_date(k, 2) end
  def internal_hour(k=1)   show_all_internal_date(k, 3) end
  def internal_minute(k=1) show_all_internal_date(k, 4) end
  def internal_second(k=1) show_all_internal_date(k, 5) end
  def internal_usec(k=1)   show_all_internal_date(k, 6) end
# alias_method :internal_mon,  :internal_month
# alias_method :internal_mday, :internal_day
# alias_method :internal_min,  :internal_minute
# alias_method :internal_sec,  :internal_second

=begin ***********
#--- Date#show_all_internal_date([k=true [, n=true]])
\  Nb̏܂łׂ̂Ă̗vfԂ܂B
\
\    k  L k Ԗڂ̓t\ɑΉlԂ悤w܂B
\       true Ȃ΁AׂĂ̗Lȓt\zŕԂ܂B
\    n  true ȂNb̏܂łׂĂ̗vfԂ܂B
\       lȂ΁AΉvf݂̂Ԃ܂B
=end =============
  def show_all_internal_date(k=true, n=true)
    a = @cal.sd_to_internal_date(sd, k)
    return a unless Numeric === n && (0..6) === n
    case k
    when false; return  a
    when true;  return (a.collect {|s| s[n]})
    else;       return  a[n]
    end
  end

=begin ***********
#--- Date#shift_internal(period=1 day)
\   period Ŏw肳ꂽԂunʓԂ܂B
\
\    period ISO8601ԕ 
=end =============
  def shift_internal(sd, period='P1D')
    @cal.shift_internal_sd(sd, period)
  end

################################################################
  alias_method :internal_mon,  :internal_month
  alias_method :internal_mday, :internal_day
  alias_method :internal_min,  :internal_minute
  alias_method :internal_sec,  :internal_second
end
