# dst.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  DDDD   SSSS TTTTT
#  D   D S       T  
#  D   D  SSS    T  
#  D   D     S   T  
#  DDDD  SSSS    T  
#
=begin #########################################################
#=DST                                                          #
\===T}[^CNX                                   #
#                                                              #
\==X[p[NX:                                             #
$==Super Class:                                                #
#*Timezone+                                                    #
=end ###########################################################

class DST < Timezone

=begin #########################################################
\==pubN CX^X \bh:                           #
$==Public Instance Method:                                     #
=end ###########################################################
  public

=begin ***********
#--- DST#zone([jd=nil])
\  Ԃ܂B
\
\  jd  vZ
=end =============
  def zone(jd=nil)
    return @zone unless jd

    sd = jd + @zone
    y, m, d = Civil.jdn_to_gc((sd + 1.to_r/2).floor)
    s, e    = [@Start, @End].collect { |p|
      @Midnight - 1.to_r / 2 +
      ( case p.length
        when 2;  Civil.gc_to_jdn(y, p[0], p[1])
        when 3;  Residue.new( p[2] + 6, 7, (p[1]>0 ? p[1]-1 : p[1])) +
                       Civil.gc_to_jdn( y, (p[1]<0 ? p[0]+1 : p[0]), 1)
        else;    raise ArgumentError, 'n should not be 0'
        end
      )
    }

    return @zone + @Diff if (s<=sd && sd<e)
    return @zone
  end

=begin ***********
#--- DST#jd_to_sd(jd)
\  EXʓnʓɕϊĕԂ܂B
\
\    jd  EXʓ
=end =============
  def jd_to_sd(jd) jd + zone(jd+@zone) end

=begin ***********
#--- DST#sd_to_jd(sd)
\  nʓEXʓɕϊĕԂ܂B
\
\    sd  nʓ
=end =============
  def sd_to_jd(sd) sd - zone(sd) end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- DST#_qualify
\  DST+IuWFNg̐`ݒ肵܂B
\
\  @Start      = Daylight Saving Time ̊Jnt ([,] or [,T,j])
\  @End        = Daylight Saving Time ̏It ([,] or [,T,j])
\  @Midnight   = Daylight Saving Time ̐ؑ֎ ()
\  @Diff       = Daylight Saving Time ̎ԍ   (, ͓씼̓~)
=end =============
  def _qualify
    @Start    ||= [ 4, 1, 0]
    @End      ||= [10,-1, 0]
    @Midnight ||= 2
    @Diff     ||= 1
    @Midnight   = @Midnight.to_r / 24
    @Diff       = @Diff.to_r     / 24
  end
end
