# emd.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  EEEEE M     M DDDD 
#  E     MM   MM D   D
#  EEEE  M M M M D   D
#  E     M  M  M D   D
#  EEEEE M     M DDDD 
#
=begin #############################################################
#=EMD                                                              #
\===̔zz܂͌̈ʒuɂČ肳             #
$===Calendar based on the ephemeris of the Sun or the Moon         #
\                                                                  #
\==X[p[NX:                                                 #
$==Super Class:                                                    #
#*Calendar+                                                        #
=end ###############################################################

class EMD < Calendar

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################

=begin ***********
#--- EMD.new([quality={})
\  EMD+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
=end =============
  def initialize(quality={})
    @Months_in_Year = 12
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==veNebh CX^X \bh:                       #
$==Prptected Instance Method:                                  #
=end ###########################################################
  protected

=begin ***********
#--- EMD#_date_to_sdn(y [, m=1 or 0 [, d=1 or 0]])
\  NEEnߒʓɕϊĕԂ܂B
\
\    y  N
\    m   (ftHgl͍ŏ̌̔ԍ)
\    d   (ftHgl͍ŏ̓̔ԍ)
=end =============
  def _date_to_sdn(y, m=@TimeUnits[0][1], d=@TimeUnits[1][1])
    _new_epoch(12 * (yy + @YearEpoch) + mm - @TimeUnits[0][1]) +
                                        dd - @TimeUnits[1][1]
  end

=begin ***********
#--- EMD#_sdn_to_date(sdn)
\  nߒʓNEEɕϊĕԂ܂B
\
\    sdn nߒʓ
=end =============
  def _sdn_to_date(sdn)
    m, d, =  Residue.mod(sdn) {|m| _new_epoch(m)}
    m, y  =  m.moddiv(12)
    m    +=  @TimeUnits[0][1]
    d    +=  @TimeUnits[1][1]
    return y-@YearEpoch, m, d
  end

=begin ***********
#--- EMD#_new_epoch(m)
\  m Ŏw肵̎n߂̒nߒʓԂ܂B
\
\    m  ԍ
=end =============
  def _new_epoch(m)
    t = @Ephemeris[0].cn_to_time( m + @CycleOffset )
    return (t + 0.5 + @Timezone[0]).floor
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- EMD#_qualify
\  EMD+IuWFNg̐`ݒ肵܂B
\
\  @Ephemeris       = ʑ̌vZɗp鑾z܂͌ Ephemeris
\  @Timezone        = vZɗp^C][
\  @YearEpoch       = Ň
\  @CycleOffset     = ʑ̃ItZbg / 360x
=end =============
  def _qualify

    @Ephemeris      ||= ['12S']
    @Ephemeris        = [@Ephemeris] unless Array === @Ephemeris
    @Ephemeris.each_index do |k|
      unless (@Ephemeris[k] = Ephemeris.get(@Ephemeris[k]))
        @Ephemeris[k] = Ephemeris.get('12S')
      end
    end

    @Timezone       ||=   [Timezone.zone.zone * 24]
    @Timezone         = [@Timezone] unless Array === @Timezone
    @Timezone.each_index do |k|
      @Timezone[k]   /=  24.to_f
    end

    @YearEpoch      ||=   0
    @CycleOffset    ||=  -1.5

    super
  end

################################################################
  func :_date_to_sdn, :_sdn_to_date, :_new_epoch
end

