# ephemeris.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  EEEEE PPPP  H   H EEEEE M     M EEEEE RRRR  I  SSSS
#  E     P   P H   H E     MM   MM E     R   R I S    
#  EEEE  PPPP  HHHHH EEEE  M M M M EEEE  RRRR  I  SSS 
#  E     P     H   H E     M  M  M E     R  R  I     S
#  EEEEE P     H   H EEEEE M     M EEEEE R   R I SSSS 
#
#
=begin #########################################################
#=Ephemeris                                                    #
\===V̈ʒuNX                                       #
#                                                              #
\==X[p[NX:                                             #
$==Super Class:                                                #
#*Outfit+                                                      #
#                                                              #
\==tŃCN[h郂W[:                       #
$==Conditionally Included Module:                              #
#*Almanac                                                      #
=end ###########################################################

class Ephemeris < Outfit

  @@outfit = {
    'Objs' => [],
    'Hash' => {},
    'Keys' => [
      [['\\d+[SLMslm]','\\d+S=>\\d+L','\\d+L=>\\d+S'] , proc{ |m| 
          Ephemeris.new('Formula'=>m[0])
        }
      ]
    ]
  }
  @@outfit['Key0'] = @@outfit['Keys'].dup

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- Ephemeris.get(key [, n=1])
\  L[Agp Ephemeris+IuWFNgIĕԂ܂B
\
\    key  V̈ʒu(Ephemeris+)L[
\    n    n ԖڂɃ}b` Ephemeris+IuWFNgI悤Ɏw
=end =============
    def get(key, n=1)
      case key
      when Ephemeris
        return key if (n -= 1) == 0
      when String
        @@outfit['Objs'].each do |item|
          item._title.each do |title|
            return item if key =~ /^#{title}$/ && (n -= 1) == 0
          end
        end
        @@outfit['Keys'].each do |item|
          [*item[0]].each do |title|
            return item[1].call($~.dup) if key =~ /^#{title}$/  && (n-=1) == 0
          end
        end
      end
      return nil
    end
  end # of class method

=begin ***********
#--- Ephemeris.new([quality={}])
\  Ephemeris+IuWFNg𐶐ĕԂ܂B
\
\    quality  `nbV
=end =============
  def initialize(quality={})
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==pubN CX^X \bh:                           #
$==Public Instance Method:                                     #
=end ###########################################################
  public

=begin ***********
#--- Ephemeris#time_to_cn(time)
\  ԍɕϊĕԂ܂B
\
\    time  EXʓ
=end =============
  def time_to_cn(time)
    ret = @Proc.call(time.to_f)
  end

=begin ***********
#--- Ephemeris#cn_to_time(sd)
\  ԍɕϊĕԂ܂B
\
\    cn  ԍ
=end =============
  def cn_to_time(cn)
    time0 =  (cn - @CN0M) / @CN1M
    _root(cn, time0) {|x| time_to_cn(x)}
  end

=begin #########################################################
\==veNebh CX^X \bh:                       #
$==Prptected Instance Method:                                  #
=end ###########################################################
  protected

=begin ***********
#--- Ephemeris#_root
\  tϊ̌vZ܂B
\
=end =============
  def _root(y0, t0, &func)
    # ߎl0,1
    # printf("y0=%20.7f\n",y0)
    t = [t0,              t0+0.1         ]
    y = [func.call(t[0]), func.call(t[1])]
    # printf("t=%20.7f,L=%20.7f\n",t[1],y[1])

    # ߎl2(1֐ɂߎ)
    t << (t[1]-t[0])/(y[1]-y[0])*(y0-y[0])+t[0]

    # JԂ
    i = 10
    while ((t[2]-t[1]).abs > 1E-6) && (i > 0)
      # \vZ
      y << func.call(t[2])
      break if (y[2]-y0).abs <= 1E-7

      # printf("t=%20.7f,L=%20.7f\n",t[2],y[2])
      t01     = t[0]-t[1]
      t02,y02 = t[0]-t[2], y[0]-y[2]
      t12,y12 = t[1]-t[2], y[1]-y[2]

      # 2֐̌W
      a = ( y02     / t02 - y12     / t12) / t01
      b = (-y02*t12 / t02 + y12*t02 / t12) / t01
      c = y[2]

      # ʎ
      d = b*b-4*a*(c-y0)
      if d < 0
        i = -1
        break
      end

      # ߎl(2֐ɂߎ)
      t << t[2] + 2*(y0-c)/(b+sqrt(d)) # <-
      t.shift
      y.shift
    end
    $stderr.puts "܂̂ŁAf[^͕ۏ؂ł܂" if i<=0
    return t[2]
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- Ephemeris#_lambda_moon_to_sun(cn)
\  ]ԍ𑾗zNԍɕϊĕԂ܂B
\
\    cn  ԍ
=end =============
  def _lambda_moon_to_sun(cn)
    lambda_sun(_root(cn, (cn - @LL0M) / @LL1M) {|x|
       lambda_moon(x) - lambda_sun(x)
    })
  end

=begin ***********
#--- Ephemeris#_lambda_sun_to_moon(cn)
\  zNԍ]ԍɕϊĕԂ܂B
\
\    cn  ԍ
=end =============
  def _lambda_sun_to_moon(cn)
    t = _root(cn, (cn - @LS0M) / @LS1M) {x| lambda_sun(x)}
    return lambda_moon(t) - lambda_sun(t)
  end

=begin ***********
#--- Ephemeris#_qualify
\  Ephemeris+IuWFNg̐`ݒ肵܂B
\
\  @Title     = Ephemeris.get ̃L[ƂȂV̈ʒu
\  @Formula   = vZΏ/̎w
\  @Precision = V̈ʒuvZ̐xw(ʏ 0)
\  @Proc      = vZ葱
\  @CN0M      =  t =       0 ł̌vZΏێԍ
\  @CN1M      =  t = 1000000 ł̌vZΏێԍ
\  @LM0M      =  t =       0 ł̍]ԍ
\  @LM1M      =  t = 1000000 ł̍]ԍ
\  @LS0M      =  t =       0 ł̑zNԍ
\  @LS1M      =  t = 1000000 ł̑zNԍ
=end =============
  def _qualify

    @Formula ||= 'S'

    @Proc    ||=
      if Hash === @Formula
        @Formula['Rem'] = ((-@Formula['Epoch']).moddiv(@Formula['Period']))[0]
        Proc {|t| (t + @Formula['Rem'])/ @Formula['Period'] }
      else
        class << self; include Almanac end
        @Title     ||= @Formula
        @Precision ||= 0
        case @Formula
        when /^(\d+)L=>(\d+)S$/
          m, s = $1.to_i, $2.to_i
          @LL0M = lambda_moon(      0) - lambda_sun(      0)
          @LL1M = lambda_moon(1000000) - lambda_sun(1000000)
          @LL1M = (@LL1M - @LL0M) / 1000000
          proc {|t| s * _lambda_moon_to_sun(t/m) }
        when /^(\d+)S=>(\d+)L$/
          s, m = $1.to_i, $2.to_i
          @LS0M = lambda_sun(      0)
          @LS1M = lambda_sun(1000000)
          @LS1M = (@LS1M - @LS0M) / 1000000
          proc {|t| m * _lambda_sun_to_moon(t/s) }
        when /^(\d+)S$/; s=$1.to_i; proc{|t|               s * lambda_sun(t) }
        when /^(\d+)s$/; s=$1.to_i; proc{|t|               s *   mean_sun(t) }
        when /^(\d+)M$/; m=$1.to_i; proc{|t|               m *lambda_moon(t) }
        when /^(\d+)m$/; m=$1.to_i; proc{|t|               m *  mean_moon(t) }
        when /^(\d+)L$/; m=$1.to_i; proc{|t| m*(lambda_moon(t)-lambda_sun(t))}
        when /^(\d+)l$/; m=$1.to_i; proc{|t| m*(  mean_moon(t)-  mean_sun(t))}
        end
      end

    @CN0M = time_to_cn(      0)
    @CN1M = time_to_cn(1000000)
    @CN1M = (@CN1M - @CN0M) / 1000000

    if @Title
      @Title = [*@Title]
      @@outfit['Objs'].push(self)
    end
  # super
  end
################################################################
  func :cn_to_time, :time_to_cn
  func :_lambda_moon_to_sun, :_lambda_sun_to_moon
end
