# fmd.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  FFFFF M     M DDDD 
#  F     MM   MM D   D
#  FFFF  M M M M D   D
#  F     M  M  M D   D
#  F     M     M DDDD 
#
=begin #############################################################
#=FMD                                                              #
\===̔zp^[̎ނ肳Ă̒ۊNX     #
$===Calendar which has some fixed arrangement rules for under year #
\  VN̓tp\bhŗ^A̔z1N̓     #
\  Ō܂B Rule-Based ȗ͂قƂǊY܂B      #
\                                                                  #
\  TuNXŐVN̓t^郁\bh _new_year Ē`     #
\  ̔zp^[ new ւ̈ŗ^܂B                   #
#                                                                  #
\==X[p[NX:                                                 #
$==Super Class:                                                    #
#*Calendar+                                                        #
=end ###############################################################

class FMD < Calendar

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################

=begin ***********
#--- FMD.new([quality={})
\  FMD+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
=end =============
  def initialize(quality={})
    raise TypeError, 'Pure virtual class: <FMD>'
#   _copy_quality(quality)
#   _qualify
  end

=begin #########################################################
\==veNebh CX^X \bh:                       #
$==Prptected Instance Method:                                  #
=end ###########################################################
  protected

=begin ***********
#--- FMD#_date_to_sdn(y [, m=1 or 0 [, d=1 or 0]])
\  NEEnߒʓɕϊĕԂ܂B
\
\    y  N
\    m   (ftHgl͍ŏ̌̔ԍ)
\    d   (ftHgl͍ŏ̓̔ԍ)
=end =============
  def _date_to_sdn(y, m=@TimeUnits[0][1], d=@TimeUnits[1][1])
    sd, key = _new_year_sd(y)
    rule = _find_rule(key)
    if (h=@HalfMoon)
      m = [m,0] unless Array === m
      d,m[1] = d+h,m[1]-1 unless m[1] % 3 == 0
    end
    return nil unless (k = _index_of_m(rule, m))
    sd += d + rule['Offset'][k]
    return  sd - @TimeUnits[1][1] if d >= 0
    return  sd + rule['Length'][k % rule['Length'].length]
  end

=begin ***********
#--- FMD#_sdn_to_date(sdn)
\  nߒʓNEEɕϊĕԂ܂B
\
\    sdn nߒʓ
=end =============
  def _sdn_to_date(sdn)
    y, d, key = _new_year_yd(sdn)
    rule = _find_rule(key)
    (0..rule['Months']-1).to_a.reverse_each do |k|
      if d >=rule['Offset'][k]
        d -= rule['Offset'][k] - @TimeUnits[1][1]
        return y, k+1, d unless rule['IDs']
        m = rule['IDs'][k]
        if (h=@HalfMoon)
          d,m[1] = d-h,m[1]+1 if d > h
        end
        return y, m, d
      end
    end
  end

=begin ***********
#--- FMD#_m_in_y(y)
\  w肵NɊ܂܂錎̐Ԃ܂B
\  (^p\̔N͍l܂)
\
\    y  N
=end =============
  def _m_in_y(y)
    return @Months_in_Year if @Months_in_Year
    @RuleTable[_new_year_sd(y)[1]]['Months']
  end

=begin ***********
#--- FMD#_d_in_y(y)
\  w肵NɊ܂܂̐Ԃ܂B
\  (^p\̔N͍l܂)
\
\    y  N
=end =============
  def _d_in_y(y)
    return @Days_in_Year if @Days_in_Year
    @RuleTable[_new_year_sd(y)[1]]['Days']
  end

=begin ***********
#--- FMD#_d_in_m(y [, m=1 or 0])
\  w肵Ɋ܂܂̐Ԃ܂B
\
\    y  N
\    m   (ftHgl͍ŏ̌̔ԍ)
=end =============
  def _d_in_m(y, m)
    return @Days_in_Month if @Days_in_Month
    rule = @RuleTable[_new_year_sd(y)[1]]
    return nil unless (k = _index_of_m(rule, m))
    return rule['Length'][k % rule['Length'].length]
  end

=begin ***********
#--- FMD#_new_year(y)
\  y Ŏw肵N̎n߂̒nߒʓԂ܂B
\  (TuNXōĒ`Ă)
\  ̃\bh Calendar+ NXŒ`Ă new_year(^p̔N)
\  Ƃ͈قȂ@̔N(11)^܂B
\
\    y  N 
=end =============
  def _new_year(y)
  end

=begin ***********
#--- FMD#_new_year_sd(y)
\  y Ŏw肵N̎n߂̒nߒʓƁA1N̓Ԃ܂B
\
\    y  N 
=end =============
  def _new_year_sd(y)
    sd1 = _new_year(y)
    sd2 = _new_year(y+1)
    return sd1, sd2-sd1
  end

=begin ***********
#--- FMD#_new_year_yd(sdn)
\  nߒʓ sdn ܂ޔNƁA̓̔N̒ʓA1N̓Ԃ܂B
\
\    sdn  nߒʓ
=end =============
  def _new_year_yd(sdn)
    return  Residue.mod(sdn) {|n| _new_year(n)}
  end

=begin ***********
#--- FMD#_index_of_m(rule, m)
\   m ̔N̎n߂̒ʌԍԂ܂B
\
\    rule zK
\    m    ^ id ܂͔ԍ
=end =============
  def _index_of_m(rule, m)
    case m
    when Numeric
      k = (m >= 0) ? m-1 : m + rule['Months']
      return k if (0...rule['Offset'].length) === k
    when Array
      k = rule['IDs'].index(m)
      return k if k
    end
    return nil
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- FMD#_find_rule(key)
\  key ɑΉ錎zKԂ܂B
\  (Ȃ key VKɌzK܂)
\
\    key  1N̓
=end =============
  def _find_rule(key)
    if !@RuleTable[key] 
      rule = {
        'Years'  => 1,
        'Months' => key.length,
        'Days'   => key.length * 29 + key.gsub(/[a-z]/,'').length,
        'IDs'    => [],
        'Length' => [],
        'Offset' => []
      }
      m = -4
      (0..key.length-1).each do |k|
        m = 0 if key[k,1].upcase == 'A'
        rule['Length'] << (key[k,1] =~ /[a-z]/ ? 29 : 30)
        rule['Offset'] << (k == 0 ? 0 : rule['Offset'][k-1]+rule['Length'][k-1])
        rule['IDs']    << [key.upcase[k] - 'A'[0] + 1, 
                          (key.upcase[k] == key.upcase[k-1] ? m+2 : m)]
      end
      @RuleTable[key] = rule
    end
    return @RuleTable[key] 
  end

=begin ***********
#--- FMD#_make_rule(key, rule)
\  new Ŏw肳ꂽzKvOŗp\ɂ܂B
\ 
\    key  zK̃nbVL[(I[o[ChɕKv)
\    rule zK
\
\*CX^Xϐ nbṼnbV@RuleTable ̗vf̗vf
#  Years  =>  1
#  Months =>  the year length / month
#  Days   =>  the year length / day 
#  IDs    =>  Array of the month IDs (Default ID is Integer)
#  Length =>  Array of the month lengths / day (Mandatory)
#  Offset =>  Array of the month offsets from the new year / day
=end =============
  def _make_rule(key, rule)

    # @RuleTable[key]['Years', 'Months', 'Offset', 'Days']
    rule['Years']  ||= 1
    rule['Months'] ||= (rule['IDs'] ? rule['IDs'] : rule['Length']).length
    rule['Offset'] = []
    sum, len = 0, rule['Length'].length
    (0..rule['Months']-1).each do |k|
      rule['Offset'] << sum
      sum += rule['Length'][k % len]
    end
    rule['Days']   ||= sum
  
    # @Months_in_Year
    case @Months_in_Year
    when 0, rule['Months'];
    when nil; @Months_in_Year = rule['Months']
    else; @Months_in_Year = 0
    end
  
    # @Days_in_Month
    if rule['Length'].length == 1 && (rule['Days'] % rule['Length'][0]) == 0
      case @Days_in_Month
      when 0, rule['Length'][0];
      when nil; @Days_in_Month = rule['Length'][0]
      else; @Days_in_Month = 0
      end
    else
      @Days_in_Month = 0
    end
  end

=begin ***********
#--- FMD#_qualify
\  FMD+IuWFNg̐`ݒ肵܂B
\
#  @RuleTable      = It defines (year,) month, day arrangement rule.
#  @HalfMoon       = If defines days in halfmoon for thai calendar
#  @Months_in_Year = If exist then every year  has defined months.
#  @Days_in_Month@= If exist then every month has defined days.
=end =============
  def _qualify
    if Array === @RuleTable
      @RuleTable = {'T' => {'Rule' => @RuleTable }}
    end

    @RuleTable.each do |key, rule|
      _make_rule(key, rule)
    end

    @Months_in_Year = nil if @Months_in_Year == 0
    @Days_in_Month  = nil if @Days_in_Month  == 0

    super
  end

################################################################
  func :_date_to_sdn, :_sdn_to_date
  func :_new_year, :_new_year_sd, :_new_year_yd
  func :_m_in_y, :_d_in_y, :_d_in_m
  func :_index_of_m
end

=begin #########################################################
\==f[^\:                                                 #
$==Data structure:                                             #
=end ###########################################################

=begin -----------
\=== @HalfMoon : E̎w
\   Integer  ̓
\    ̕ϐ݂Ƃ́A1𔒕ƍɕ܂B̍ŏ
\    @HalfMoon ԂAȍ~łB̎wKvƂ̂̓^
\    Ĉ݂łB
=end -------------

=begin -----------
\=== @Months_in_Year : 1Ň
\=== @Days_in_Month  : 1̓
\   Integer
\    _qualify @@RuleTable ͂A̐Ɉł 
\    邱ƂȂ΁A̕ϐɂ̒lݒ肵܂BCalendar#
\    _qualify ́A̕ϐQƂāA@TimeUnits ̐ݒs܂B
=end -------------

=begin #########################################################
\=== @RuleTable : ̔z[`e[u           #
\  Hash                                                        #
\   FMD+IuWFNg̓nbṼnbV@RuleTableɃ[ #
\   ێĂ܂Bȉ̃nbV̗vf̐łBȂA #
\   nbṼL[̎擾@́ATuNXɂĈقȂ܂B #
=end ###########################################################

=begin -----------
\==== 'Years'  : [̎̒(NP)
\==== 'Months' : [̎̒(P)
\==== 'Days'   : [̎̒(P)
\  Integer
\
\    nbVŒ`郋[̎̒ꂼ̒Pʂŕ\܂B
\    N̒̌̔zu`郋[ł́A'Years'͏ 1 łB
\    Avf'Months'͎gĂ܂B
=end -------------

=begin -----------
\==== 'IDs'  : ID
\  Array [ID, ...]
\
\    nbVŒ`郋[ł́AID̔zuێ܂B
\    [̂Ȃ@ł́AID͒PȂʂԍ()Ȃ̂ŁA
\    ̗vf͕svłB
=end -------------

=begin -----------
\==== 'Length'  : ̓
\  Array [̓, ...]
\
\    nbVŒ`郋[ł́Ae̓ێ܂B
\    ̃f[^͕Kw肵Ȃ΂Ȃ܂B
=end -------------

=begin -----------
\==== 'Offset'  : ̊JñItZbg
\  Array [̊JñItZbg, ...]
\
\    nbVŒ`郋[ł́Ae̊Jn̔N̓ێ
\    ܂B_qualify  'Length' 玩̂Ń[Uw肷
\    Ƃ͒ʏ킠܂B
=end -------------
