# fmd0.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  FFFFF M     M DDDD   000 
#  F     MM   MM D   D 0   0
#  FFFF  M M M M D   D 0   0
#  F     M  M  M D   D 0   0
#  F     M     M DDDD   000 
#
=begin ###############################################################
#=FMD0                                                               #
\===\ɂ鑾Az                                   #
$===Luni-Solar calendar which uses year / month /day table           #
#                                                                    #
\==X[p[NX:                                                   #
$==Super Class:                                                      #
#*FMD+                                                               #
=end #################################################################

class FMD0 < FMD

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################

=begin ***********
#--- FMD0.new([quality={})
\  FMD0+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
=end =============
  def initialize(quality={})
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- FMD0#_new_year(year)
\  y Ŏw肵N̎n߂̒nߒʓԂ܂B
\
\    y  N 
=end =============
  def _new_year(year) _new_year_sd(year)[0] end

=begin ***********
#--- FMD0#_new_year_sd(year)
\  year Ŏw肵N̎n߂̒nߒʓƁA1N̓Ԃ܂B
\
\    year  N 
=end =============
  def _new_year_sd(year)
    rule  = @RuleTable[@EntryKey]
    year, count  = (year - @YearEpoch).moddiv(rule['Years'])
    key, sd, = rule['Rule'][year]
    return @DayEpoch + sd + count * rule['Days'], key
  end

=begin ***********
#--- FMD0#_new_year_yd(sdn)
\  nߒʓ sdn ܂ޔNƁA̓̔N̒ʓA1N̓Ԃ܂B
\
\    sdn  nߒʓ
=end =============
  def _new_year_yd(sdn)
    year, day, = Residue.mod(sdn) {|n| _new_year(n)} 
    sd, key = _new_year_sd(year)
    return year, day, key
  end

=begin ***********
#--- FMD0#_make_rule(key, rule)
\  new Ŏw肳ꂽzKvOŗp\ɂ܂B
\ 
\    key  NzK̃nbVL[
\    rule NzK
\
\*CX^Xϐ nbṼnbV@RuleTable ̗vf
#  Years  =>  the period length / year
#  Months =>  the period length / month
#  Days   =>  the period length / day 
#  Rule   =>  Array of sub rules' key and offset
=end =============
  def _make_rule(key, rule)

    mm, dd = 0, 0
    rule['Rule'].each_index do |k|
      subkey = rule['Rule'][k]
      rule['Rule'][k] = [subkey, dd, mm]
      mm += subkey.length
      dd += subkey.length * 29 + subkey.gsub(/[a-z]/,'').length
    end

    rule['Years']  ||= rule['Rule'].length
    rule['Months'] ||= mm
    rule['Days']   ||= dd

    @EntryKey ||= key
  end

################################################################
  func :_new_year, :_new_year_sd, :_new_year_yd
end

=begin #########################################################
\==f[^\:                                                 #
$==Data structure:                                             #
=end ###########################################################

