# fmd1.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  FFFFF M     M DDDD   1 
#  F     MM   MM D   D 11 
#  FFFF  M M M M D   D  1 
#  F     M  M  M D   D  1 
#  F     M     M DDDD  111
#
=begin ###############################################################
#=FMD1                                                               #
\===N̔zp^[肳Ă(ftHg̓CX)       #
$===Calendar which has some fixed arrangement rules of year pattern  #
#                                                                    #
\==X[p[NX:                                                   #
$==Super Class:                                                      #
#*FMD+                                                               #
=end #################################################################

class FMD1 < FMD

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- FMD1.instance(key)
\  ɑΉCX^X𐶐܂B
\
\    key  CX^Xw肷镶
=end =============
    def instance(key)
      case key
      when /^Islam$/i
        FMD1.new(
          'Title'     => 'Islam',
          'DayBorder' =>  18,
          'MonthNames'=> %w( Muharram  Safar      Rabi\ I      Rabi\ II
                             Jumada\ I Jumada\ II Rajab        Shaban
                             Ramadan   Shawwal    Dhu\ al-Qada Dhu\ al-Hijja ),
          'YearEpoch' =>        0,
          'DayEpoch'  =>  1948440-354,
          'RuleTable' => {
           'T' => {'Rule'  =>[['L',2], 'S', ['L',3], 'S', ['L',2], 'S', 'L']},
           'L' => {'Rule'  =>[0,0,1]},
           'S' => {'Rule'  =>[0,1  ]},
            0  => {'Length'=>[30,29,30,29,30,29,30,29,30,29,30,29]},
            1  => {'Length'=>[30,29,30,29,30,29,30,29,30,29,30,30]}
          }
        )
      else; nil
      end
    end
  end # of class method

=begin ***********
#--- FMD1.new([quality={})
\  FMD1+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
=end =============
  def initialize(quality={})
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- FMD1#_new_year(y)
\  y Ŏw肵N̎n߂̒nߒʓԂ܂B
\
\    y  N 
=end =============
  def _new_year(y) _new_year_sd(y)[0] end

=begin ***********
#--- FMD1#_new_year_sd(y)
\  y Ŏw肵N̎n߂̒nߒʓƁA1N̓Ԃ܂B
\
\    y  N 
=end =============
  def _new_year_sd(y)
    rule = @RuleTable[@EntryKey]
    value, count = (y - @YearEpoch).moddiv(rule['Years'])
    sd, y, key = _read_period(@EntryKey, 
                 'Years', value, 
                 'Days',  @DayEpoch + count * rule['Days'])
    return sd, key
  end

=begin ***********
#--- FMD1#_new_year_yd(sdn)
\  nߒʓ sdn ܂ޔNƁA̓̔N̒ʓA1N̓Ԃ܂B
\
\    sdn  nߒʓ
=end =============
  def _new_year_yd(sdn)
    rule = @RuleTable[@EntryKey]
    value, count = (sdn - @DayEpoch).moddiv(rule['Days'])
    _read_period( @EntryKey, 
    'Days',   value,
    'Years',  @YearEpoch  + count * rule['Years'])
  end

=begin ***********
#--- FMD1#_read_period(key, akey, avalue, zkey, zvalue)
\  N̔zKǂݏo܂B
\
\    key    N̔zK̃L[
\    akey   ͂'Days''Years'w
\    avalue ͂'Days'܂'Years'̒l
\    zkey   o͂'Years''Days'w
\    zvalue o͂'Years'܂'Days'̒l
=end =============
  def _read_period(key, akey, avalue, zkey, zvalue)
    rule = @RuleTable
    rule[key]['Rule'].each do |part|
      subkey, count, = [*part] << 1
      if avalue >= count * rule[subkey][akey]
        avalue -= count * rule[subkey][akey]
        zvalue += count * rule[subkey][zkey]
      else
        avalue, count = avalue.moddiv(rule[subkey][akey])
        zvalue += count * rule[subkey][zkey]
        return zvalue, avalue, subkey if Numeric === subkey
        return _read_period(subkey, akey, avalue, zkey, zvalue)
      end
    end
  end

=begin ***********
#--- FMD1#_make_rule(key, rule)
\  new Ŏw肳ꂽzKvOŗp\ɂ܂B
\ 
\    key  NzK̃nbVL[
\    rule NzK
\
\*CX^Xϐ nbṼnbV@RuleTable ̗vf
#  Years  =>  the period length / year
#  Months =>  the period length / month
#  Days   =>  the period length / day 
#  Rule   =>  Array of sub rules' key
=end =============
  def _make_rule(key, rule)
    case key
    when Numeric # Table of One Year
      super

    when String  # Table of Many Years
      ['Years', 'Months', 'Days'].each do |unit|
        rule[unit] ||= 
          begin
            s = 0
            rule['Rule'].each do |part|
              subkey, count, = [*part] << 1
              subrule = @RuleTable[subkey]
              _make_rule(subkey, subrule) if !subrule[unit]
              s += count * subrule[unit]
            end
            s
          end
      end
      if !@EntryKey ||
          @RuleTable[@EntryKey]['Days'] < rule['Days']
        @EntryKey = key
      end
    end
  end

=begin ***********
#--- FMD1#_qualify
\  FMD1+IuWFNg̐`ݒ肵܂B
\
=end =============
  def _qualify

    @Title      ||= 'Islam'
    @DayBorder  ||=  18
    @MonthNames ||= %w( Muharram   Safar       Rabi\ I       Rabi\ II
                        Jumada\ I  Jumada\ II  Rajab         Shaban
                        Ramadan    Shawwal     Dhu\ al-Qada  Dhu\ al-Hijja )
    @YearEpoch  ||=        0
    @DayEpoch   ||=  1948440-354
    @RuleTable  ||= {
      'T' => {'Rule'  =>[['L',2], 'S', ['L',3], 'S', ['L',2], 'S', 'L']},
      'L' => {'Rule'  =>[0,0,1]},
      'S' => {'Rule'  =>[0,1  ]},
       0  => {'Length'=>[30,29,30,29,30,29,30,29,30,29,30,29]},
       1  => {'Length'=>[30,29,30,29,30,29,30,29,30,29,30,30]}
    }

    super
  end
################################################################
  func :_new_year, :_new_year_sd, :_new_year_yd
end

=begin #########################################################
\==f[^\:                                                 #
$==Data structure:                                             #
=end ###########################################################

=begin -----------
\=== @YearEpoch : [Œ`ꂽ̌̐N
\=== @DayEpoch  : [Œ`ꂽ̌̒nߒʓ
\   Integer
\    ̕ϐɂA[Œ`ꂽ@ΎԎɔzu܂B
=end -------------

=begin #########################################################
\=== @RuleTable : N̔z[`e[u             #
\  Hash                                                        #
\   FMD1+IuWFNg̓nbṼnbV@RuleTableɃ[  #
\   ێĂ܂B͂̃nbV̗vf̐łB     #
=end ###########################################################

=begin -----------
\==== 'Rule'  : [̂`L[ȂnbV
\  Hash {ʃL[ => [[ʃL[,JԂ], ..], ...}
\
\    ʃL[Œ`郋[AʃL[Œ`郋[̌JԂ
\    ܂ރV[PXȂ邱ƂAċNIɒ`Ă܂BŉʃL[́A
\    X[p[NXł FMD+Œ`z[ێĂ܂B
=end -------------

