# initial.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  I N   N I TTTTT I   A   L    
#  I NN  N I   T   I  A A  L    
#  I N N N I   T   I A   A L    
#  I N  NN I   T   I AAAAA L    
#  I N   N I   T   I A   A LLLLL
#
=begin #########################################################
#=Initial                                                      #
\===@f[^x[Xݒl                                 #
\                                                              #
\  @f[^sɎ擾邽߂̃u[gXgbvłB  #
\                                                              #
=end ###########################################################

## required scripts for outfits
require 'when/outfit'
require 'when/residue'
require 'when/timezone'
autoload('DST',      'when/dst'      )
autoload('Ephemeris','when/ephemeris')
autoload('Almanac',  'when/almanac'  )
autoload('MoonSun',  'when/moonsun'  )

## required scripts for calendars
autoload('Civil',    'when/civil'    )
autoload('Eras',     'when/eras'     )
autoload('Japan',    'when/japan'    )
autoload('DMD',      'when/dmd'      )
autoload('EMD',      'when/emd'      )
autoload('ChinaB',   'when/chinab'   )
autoload('ChinaJ',   'when/chinaj'   )
autoload('ChinaS',   'when/chinas'   )
autoload('Tibet',    'when/tibet'    )
autoload('IndiaB',   'when/indiab'   )
autoload('FMD',      'when/fmd'      )
autoload('FMD0',     'when/fmd0'     )
autoload('FMD1',     'when/fmd1'     )
autoload('FMD2',     'when/fmd2'     )
autoload('Jewish',   'when/jewish'   )
autoload('Week',     'when/week'     )
autoload('Easter',   'when/easter'   )
autoload('ThaiB',    'when/thaib'    )
autoload('ThaiC',    'when/thaic'    )

class Calendar < Outfit

  @@outfit = {
    'Keys' => [
      ['Italy'    , proc{ Civil.instance('Italy')      }],
      ['Gregorian', proc{ Civil.instance('Gregorian')  }],
      ['Julian'   , proc{ Civil.instance('Julian')     }],
      ['Week'     , proc{ Week.instance('Week')        }],
      ['Easter'   , proc{ Easter.instance('Easter')    }],
      ['Jewish'   , proc{ Jewish.instance('Jewish')    }],
      ['Islam'    , proc{ FMD1.instance('Islam')       }],
      ['Iran'     , proc{ FMD2.instance('Iran')        }],
      ['IndiaD'   , proc{ DMD.instance('IndiaD')       }],
      ['IndiaB'   , proc{ IndiaB.instance('IndiaB')    }],
      ['ThaiB'    , proc{ ThaiB.instance('ThaiB')      }],
      ['ThaiC'    , proc{ ThaiC.instance('ThaiC')      }],
      ['Tibet'    , proc{ Tibet.instance('Tibet')      }],
      ['ChinaJ'   , proc{ ChinaJ.instance('ChinaJ')    }],
      ['JapanEras', proc{ Japan.instance('JapanEras')  }],
      ['JapanFMD0', proc{ Japan.instance('JapanFMD0')  }],
      [['BCE','CE'],      proc{ Eras.instance('BCECE') }],
      [['BC', 'AD'],      proc{ Eras.instance('BCAD')  }],
      [['M','T','S','H'], proc{ Eras.instance('MTSH')  }]
    ],
    'Hash' => {},
    'Objs' => []
  }

  @@outfit['Key0'] = @@outfit['Keys'].dup

  class << self
=begin ***********
#--- Calendar.instance(key)
\  ɑΉCX^X𐶐܂B
\
\    key  CX^Xw肷镶
=end =============
    def instance(key)
      nil
    end
  end # of class method
end
