# residue.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  RRRR  EEEEE  SSSS I DDDD  U   U EEEEE
#  R   R E     S     I D   D U   U E    
#  RRRR  EEEE   SSS  I D   D U   U EEEE 
#  R  R  E         S I D   D U   U E    
#  R   R EEEEE SSSS  I DDDD   UUU  EEEEE
#
=begin #########################################################
#=Residue                                                      #
\===]                                                     #
#                                                              #
\==X[p[NX:                                             #
$==Super Class:                                                #
#*Outfit+                                                      #
=end ###########################################################

class Residue < Outfit

  @@outfit = {
    'Objs' => [],
    'Hash' => {},
    'Keys' => []
  }
  @@outfit['Key0'] = @@outfit['Keys'].dup

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- Residue.default_keys(keys, offset)
\  ftHǧL[ƑΉ葱ꊇēo^܂B
\
\    keys   ](Residue+)L[̔z
\    offset ŏ̌L[ɑ΂]
=end =============
    def default_keys(keys, offset)

      hash = {}
      keys = keys.collect {|key| key.downcase}
      keys.each_index {|i| hash[keys[i]] =  i}
      p = keys.join('|')
      s = keys.size

      Residue.register("last\\s+(#{p})") { |m|
        Residue.new((hash[m[1].downcase]+offset) % s, s, -1, m[0])
      }
      Residue.register("first\\s+(#{p})") { |m|
        Residue.new((hash[m[1].downcase]+offset) % s, s,  0, m[0])
      }
      Residue.register("second\\s+(#{p})") { |m|
        Residue.new((hash[m[1].downcase]+offset) % s, s,  1, m[0])
      }
      Residue.register("third\\s+(#{p})") { |m|
        Residue.new((hash[m[1].downcase]+offset) % s, s,  2, m[0])
      }
      Residue.register("(\\d*1)st\\s+(#{p})") { |m|
        Residue.new((hash[m[2].downcase]+offset) % s, s, m[1].to_i-1, m[0])
      }
      Residue.register("(\\d*2)nd\\s+(#{p})") { |m|
        Residue.new((hash[m[2].downcase]+offset) % s, s, m[1].to_i-1, m[0])
      }
      Residue.register("(\\d*3)rd\\s+(#{p})") { |m|
        Residue.new((hash[m[2].downcase]+offset) % s, s, m[1].to_i-1, m[0])
      }
      Residue.register("(\\d+)th\\s+(#{p})") { |m|
        Residue.new((hash[m[2].downcase]+offset) % s, s, m[1].to_i-1, m[0])
      }
    end

=begin ***********
#--- Residue.get(key [, n=1])
\  L[Agp Residue+IuWFNgIĕԂ܂B
\
\    key  ](Residue+)L[
\    n    n ԖڂɃ}b` Residue+IuWFNgI悤Ɏw
=end =============
    def get(key, n=1)
      case key
      when Residue
        return key if (n -= 1) == 0
      when String
        @@outfit['Objs'].each do |item|
          item._title.each do |title|
            match = title.sub(/^([-+])/, '[\1]')
            return item if key =~ /^#{match}$/i && (n -= 1) == 0
          end
        end
        @@outfit['Keys'].each do |item|
          [*item[0]].each do |title|
            match = title.sub(/^([-+])/, '[\1]')
            return item[1].call($~.dup) if key =~ /^#{match}$/i && (n-=1) == 0
          end
        end
      end
      return nil
    end

=begin ***********
#--- Residue.mod(nn, &dd)
\  nn  dd Łuv(quot), ](rem)я(div)Ԃ܂B
\  ]͔񕉁A Integer* łB
\
\    nn  폜
\    dd     nn  = rem + dd(quot)
\           div = dd(quot+1)-dd(quot)
\        ƂȂ悤 rem, div, quot ߂葱
=end =============
    def mod(nn, &dd)
      u = dd.call(0)
      y = ((nn-u)*256).moddiv(dd.call(256)-u)[1] - 1
      w1, w2 = dd.call(y), dd.call(y+1)
      until  w1 <= nn && nn < w2
        if w2 <= nn then  y, w1, w2 = y+1, w2, dd.call(y+2)
        else              y, w1, w2 = y-1, dd.call(y-1), w1
        end
      end
      return y, nn-w1, w2-w1
    end

=begin ***********
|--- Residue.gcd(a, b)
|  ő񐔂ƒ]vZ̕⏕萔(q,p)Ԃ܂B
|
|    a, b  
=end =============
    def gcd(a, b)

      x0, x1 = a.to_i, b.to_i
      p0, p1 = 1,      x0/x1
      q0, q1 = 0,      1

      until (x2 = x0 % x1) == 0 do
        k  = x1 / x2
        p2 = p1 * k + p0
        q2 = q1 * k + q0
        x0, p0, q0 = x1, p1, q1
        x1, p1, q1 = x2, p2, q2
      end

      return x1, q0, p0
    end

=begin ***********
#--- Residue.china(an, ad, bn, bd)
#  ](xn, xd)Ԃ܂B
\
\  ł́A]
\    xd Ŋ xn ]  (ad Ŋ an ])  (bd Ŋ bn ])
\  ƂȂ悤ȑg (xn, xd) ̂ƂƂ܂B
\
\    an, ad, bn, bd  
=end =============
    def china(an, ad, bn, bd)
      if (ad >= bd)
        ad, bd = ad.to_i, bd.to_i
        an, bn = an.to_i, bn.to_i
      else
        ad, bd = bd.to_i, ad.to_i
        an, bn = bn.to_i, an.to_i
      end

      raise ArgumentError, 'invalid divider' if bd < 0
      return an, ad if bd == 0

      g, q, p = gcd(ad, bd)
      return ((bn*ad*q - an*bd*p) * (ad*q - bd*p)) % (ad*bd), ad*bd if (g==1)

      r = an % g
      s = bn % g
      raise ArgumentError, 'divider mismatch' unless r == s

      mn, md = china((an-r)/g, ad/g, (bn-s)/g, bd/g)
      return mn * g + r, md * g
    end
  end # of class method

=begin ***********
#--- Residue.new(rem, div [, quot=0 [, *quality])
\  Residue+IuWFNg𐶐ĕԂ܂B
\
\    name Residue+IuWFNg̖O
\    rem  ]
\    div  
\    quot 
\    quality  `nbV
=end =============
  def initialize(rem, div, quot=0, *quality)
    @div    = div.abs
    @rem, d = rem.moddiv(@div)
    @quot   = quot.to_i + d
    quality = {} if quality == []
    quality = {'Title'=>[*quality]} if Array === quality
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==pubN CX^X \bh:                           #
$==Public Instance Method:                                     #
=end ###########################################################
  public

=begin ***********
#--- Residue#rem
#--- Residue#div
#--- Residue#quot
\  ꂼA]AAԂ܂B
=end =============
  attr_reader :rem, :div, :quot

=begin ***********
#--- Residue#new_quot(q)
\  Residue+IuWFNg𕡐āAquotݒ肵܂B
\
\    q  V
=end =============
  def new_quot(q)
    type.new(rem, div, q)
  end

=begin ***********
#--- Residue#>>(n)
\  Residue+IuWFNg𕡐āAquot  n 傫ݒ肵܂B
\
\    n  quot ɉ鐮
=end =============
  def >>(n)
    type.new(rem, div, quot + n)
  end

=begin ***********
#--- Residue#<<(n)
\  Residue+IuWFNg𕡐āAquot  n ݒ肵܂B
\
\    n  quot 
=end =============
  def <<(n)
    type.new(rem, div, quot - n)
  end

=begin ***********
#--- Residue#*(other)
\  Residue+IuWFNg self, other ̗̏𓯎ɖ
\  Residue+IuWFNg(])Ԃ܂B
\  self, other ͖̏܂B
\
\    other Residue+IuWFNg
=end =============
  def * (other)
    case other
    when Residue
      type.new(*type.china(rem, div, other.rem, other.div))
    else
      raise ArgumentError, 'invalid operand type'
    end
  end

=begin ***********
#--- Residue#+(other)
\  other ɂāuself.div Ŋ self.rem ]lvԂ܂B
\  self.quot  0 ̏ꍇAother Ȃŏ̒lƂȂA
\  self.quot  n ƁAl n * self.div ܂B
\
\    other Numeric*IuWFNg܂Date*IuWFNg
=end =============
  def + (other)
    case other
    when Numeric
      r, d = other.moddiv(div)
      return (r<=rem) ? (d+quot) * div + rem : (d+quot+1) * div + rem
    when Date
      r, d = other.sd.moddiv(div)
      sd = (r<=rem) ? (d+quot) * div + rem : (d+quot+1) * div + rem
      return Date.new(other.cal, sd, other.zone)
    else
      raise ArgumentError, 'invalid operand type'
    end
  end

=begin ***********
#--- Residue#+@ (one operand operator '+')
\  self ̕Ԃ܂B
=end =============
  def +@
    self.dup
  end

=begin ***********
#--- Residue#-@ (one operand operator '-')
\  self 𕡐āAquot  -1 - quot ɐݒ肵܂B
=end =============
  def -@
    self.new_quot(-1-quot)
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- Residue#_qualify
\  Residue+IuWFNg̐`ݒ肵܂B
\
\  @Title      = Residue.get ̃L[ƂȂ]ޖ
=end =============
  def _qualify
    if @Title
      @Title = [*@Title]
      @@outfit['Objs'].push(self)
    end
  end
end

=begin #########################################################
\==NX̃CX^X \bh̒ǉ:                      #
$==Other class' Instance Method:                               #
=end ###########################################################

=begin ***********
#--- Numeric#moddiv(dd)
\  self  dd Ŋ]肨яԂ܂B
\  ]͔񕉁A Integer* łB
\
\    dd  
=end =============
class Numeric
  def moddiv(dd)
    quot, rem = self.divmod(dd)
    if rem < 0
      rem  += dd.abs
      quot -= (dd <=> 0)
    end
    return rem, quot.to_i
  end
end

=begin ***********
#--- Float#to_r
\  ŗǋߎp Float*  Rational* ɕϊ܂B
=end =============
class Float
  def to_r

    return 0 if self == 0

    z = self.abs
    k = z.to_i
    s = (z / self).to_i

    p0, p1 = 1, k
    q0, q1 = 0, 1

    until (self.abs - p1.to_f / q1).abs < 0.1/86400000000
      z  = 1.0/(z-k)
      k  = z.to_i
      p0, p1 = p1, p1 * k + p0
      q0, q1 = q1, q1 * k + q0
    end
#   return s * p1 if q1 == 1
    return Rational(s * p1, q1)
  end
end
