# thaib.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  TTTTT H   H   A   I BBBB 
#    T   H   H  A A  I B   B
#    T   HHHHH A   A I BBBB 
#    T   H   H AAAAA I B   B
#    T   H   H A   A I BBBB 
#
=begin ##########################################################
#=ThaiB                                                         #
\===^C̗                                                #
$===Thai Calendar                                               #
#                                                               #
\==X[p[NX:                                              #
$==Super Class:                                                 #
#*ThaiC+                                                        #
=end ############################################################

class ThaiB < ThaiC

  YEAR_TYPE = {'A'=>354, 'B'=>355, 'C'=>384, 'D'=>384, 'E'=>384}

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- ThaiB.instance(key)
\  ɑΉCX^X𐶐܂B
\
\    key  CX^Xw肷镶
=end =============
    def instance(key)
      case key
      when /^ThaiB$/i
        _NormalIDs    =   [[ 1,0],[ 2, 0],[ 3,0],[ 4,0],[ 5,0],[ 6,0],
                           [ 7,0],[ 8, 0],[ 9,0],[10,0],[11,0],[12,0]]
        _LeapIDs      =   [[ 1,0],[ 2, 0],[ 3,0],[ 4,0],[ 5,0],[ 6,0],
                           [ 7,0],[ 8,-3],[ 8,0],[ 9,0],[10,0],[11,0],[12,0]]
        ThaiB.new(
          'Title'     =>  'ThaiB',
          'NormalIDs' =>  _NormalIDs,
          'LeapIDs'   =>  _LeapIDs,
          'MonthNames'=>  %w( Margasirsa  Pausha      Magha    Phalguna 
                              Chaitra     Vaisakha    Jyeshta  Ashada  
                              Sravana     Bhadrapada  Asvina   Kartika  ),
          'LeapNames' =>  [[0, "%s"], [-3, "Adika Ashada", 8]],
          'RuleTable' =>  {
            354 => {'Length'=>[29,30,29,30,29,30,29,30,29,30,29,30],
                    'IDs'   => _NormalIDs},
            355 => {'Length'=>[29,30,29,30,29,30,30,30,29,30,29,30],
                    'IDs'   => _NormalIDs},
            384 => {'Length'=>[29,30,29,30,29,30,29,30,30,29,30,29,30],
                    'IDs'   => _LeapIDs}
          }
        )
      else; nil
      end
    end
  end # of class method

=begin ***********
#--- Thai.new([quality={})
\  ThaiB+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
=end =============
# def initialize(quality={})
#   _copy_quality(quality)
#   _qualify
# end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- Thai#_new_year(y)
\  y Ŏw肵N̎n߂̒nߒʓԂ܂B
\  (@1)
\    y  N 
=end =============
  def _new_year(y)
    e0,dir0  = _thai(y,  0)
    e1,dir1  = _thai(y+1,0)
    e0['T'] -= 1 if (e1['T'] - e0['T'] < YEAR_TYPE[dir0])
    return @DayEpoch + e0['T'] - 29*2 - 30*2
  end

=begin ***********
#--- Thai#_eph(y)
\  y Ŏw肵N̗萔Ԃ܂B
\
\    y  N 
=end =============
  def _eph(y) # C
    h = ((y-@YearEpoch)*292207+373+800*1).moddiv(800)
  # u = (h[1]+2611).moddiv(3232)
    a = (h[1]*11+650).moddiv(692)
    m = (h[1]+a[1]+0).moddiv(30)
    h[0] *= 125
    return {'H'=>h, 'A'=>a, 'M'=>m}
  end

=begin ***********
#--- Thai#_thai(y, dir)
\  y Ŏw肵N̕[A8̑召𔻒肵܂B
\
\    y   N
\    dir Ỏ[Ԃ\R[h
=end =============
  def _thai(y,dir)
    # ̌vZ
    e,w = super(y,dir)

    # J_[̃^Cv 
    if (e['c'])
      if (!e['b'])
        return  e,'C'   # ʂ̉[N   
      elsif ((0<e['t']) && (e['t']<6))
        return  e,'D'   # ON̉[N 
      else
        return  e,'E'   # N̉[N 
      end
    else
      if (e['b'])
        return  e,'B'   # ̕N 
      elsif ((dir != -1) && (_thai(y+1,+1)[1]=='D'))
        return  e,'B'   # ̕N 
      elsif ((dir != +1) && (_thai(y-1,-1)[1]=='E'))
        return  e,'B'   # ̕N 
      else
        return  e,'A'   # ̕N 
      end
    end
  end

=begin ***********
#--- Thai#_qualify
\  ThaiB+IuWFNg̐`ݒ肵܂B
\
=end =============
# def _qualify
#
#   super
# end
################################################################
  func :_new_year
end
