# thaic.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  TTTTT H   H   A   I  CCC 
#    T   H   H  A A  I C   C
#    T   HHHHH A   A I C    
#    T   H   H AAAAA I C   C
#    T   H   H A   A I  CCC 
#
=begin ##########################################################
#=ThaiC                                                         #
\===̃^C̗                                            #
$===ThaiC Calendar                                              #
#                                                               #
\==X[p[NX:                                              #
$==Super Class:                                                 #
#*FMD+                                                          #
=end ############################################################

class ThaiC < FMD

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- ThaiC.instance(key)
\  ɑΉCX^X𐶐܂B
\
\    key  CX^Xw肷镶
=end =============
    def instance(key)
      _NormalIDs      =   [[ 1,0],[ 2,0],[ 3, 0],[ 4,0],[ 5,0],[ 6,0], 
                           [ 7,0],[ 8,0],[ 9, 0],[10,0],[11,0],[12,0]]
      _LeapIDs        =   [[ 1,0],[ 2,0],[ 3, 0],[ 4,0],[ 5,0],[ 6,0],
                           [ 7,0],[ 8,0],[ 9,-3],[ 9,0],[10,0],[11,0],[12,0]]
      case key
      when /^ThaiC$/i
        ThaiC.new(
          'Title'     =>  'ThaiC',
          'YearBorder'=>   {'Offset' => 0},
          'DayBorder' =>   6,
          'NormalIDs' =>  _NormalIDs,
          'LeapIDs'   =>  _LeapIDs,
          'MonthNames'=>  %w(
             Kartika   Margasirsa  Pausha  Magha    Phalguna    Chaitra
             Vaisakha  Jyeshta     Ashada  Sravana  Bhadrapada  Asvina
          ),
          'LeapNames' =>  [[0, "%s"], [-3, "Adika Ashada", 9]],
          'HalfMoon'  =>  15,
          'RuleTable' =>  {
            354 => {'Length'=>[30,29,30,29,30,29,30,29,30,29,30,29],
                    'IDs'   => _NormalIDs},
            355 => {'Length'=>[30,29,30,29,30,29,30,30,30,29,30,29],
                    'IDs'   => _NormalIDs},
            356 => {'Length'=>[30,29,30,29,30,29,30,30,30,29,30,30],
                    'IDs'   => _NormalIDs},
            383 => {'Length'=>[29,30,29,30,29,30,29,30,29,30,29,30,29],
                    'IDs'   => _LeapIDs},
            384 => {'Length'=>[30,29,30,29,30,29,30,29,30,30,29,30,29],
                    'IDs'   => _LeapIDs},
          },
          'YearEpoch' =>      638 + 543,
          'DayEpoch'  =>  1954168,
          'MeanMonth' =>       29 + Rational(373, 703)
        )
      else; nil
      end
    end
  end # of class method

=begin ***********
#--- ThaiC.new([quality={})
\  ThaiC+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
=end =============
  def initialize(quality={})
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==pubN CX^X \bh:                           #
$==Public Instance Method:                                     #
=end ###########################################################
  public

=begin ***********
#--- ThaiC#new_year(y)
\  y Ŏw肵N̎n߂̒nߒʓԂ܂B
\  (^p̔N - Ȃ킿\N[)
\    y  N 
=end =============
  def new_year(y)
    e = _eph(y)
    return @DayEpoch -1 + e['H'][1]
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

=begin ***********
#--- ThaiC#_new_year(y)
\  y Ŏw肵N̎n߂̒nߒʓԂ܂B
\  (@11)
\    y  N 
=end =============
  def _new_year(y)
    e0 = _thai(y,  0)[0]
    e1 = _thai(y+1,0)[0]
    e0['T'] -= 1 if (e1['T']-e0['T'] == 353)
    return @DayEpoch - 1 + e0['T'] - 30*3 - 29*2
  end

=begin ***********
#--- ThaiC#_eph(y)
\  y Ŏw肵N̗萔Ԃ܂B
\
\    y  N 
=end =============
  def _eph(y) # C
    y -= @YearEpoch
    h  = (y+4).moddiv(9)[1]                   # y
    h  = (y-h).moddiv(3)[1]                   # z
    h  = (y+1-h).moddiv(2)[1]                 # r (2 => h?)
    h  = (36525876*y+149049-h).moddiv(100000) # s
    a  = (h[1]*11+633-((h[1]+7368).moddiv(8878))[1]).moddiv(692)
    m  = (h[1]+a[1]+0).moddiv(30)
    return {'H'=>h, 'A'=>a, 'M'=>m}
  end

=begin ***********
#--- ThaiC#_thai(y, dir)
\  y Ŏw肵N̕[A8̑召𔻒肵܂B
\
\    y   N
\    dir Ỏ[Ԃ\R[h
=end =============
  def _thai(y,dir)
      # ̌vZ 
    e = _eph(y)
    k = 800*125 - e['H'][0]
    t = e['M'][0]

      # Jyaistha ̔ 
    b = ((e['A'][0]<126) && (k<=207*125)) || ((e['A'][0]<137) && (k> 207*125))

      # [N̔
    c = ((t<6) || (t>24))
    c = true  if ((t==24) && (_thai(y+1,+1)[1]< 'C'))
    c = false if ((t==25) && (_thai(y+1,+1)[1]>='C'))

      # Caitra  0  
    e['T'] = e['H'][1] - t
    e['T'] -= 1  if (t==0)
    e['T'] -= 29 if (c && (t<=6))
    e['b'] = b
    e['c'] = c
    e['t'] = t
    return e,' '
  end

=begin ***********
#--- ThaiC#_qualify
\  ThaiC+IuWFNg̐`ݒ肵܂B
\
=end =============
# def _qualify
#
#   super
# end
################################################################
  func :new_year, :_new_year
end
