# tibet.rb: written by Takashi SUGA 2002-03-20 v0.3(suchowan@box.email.ne.jp)
#
#  TTTTT I BBBB  EEEEE TTTTT
#    T   I B   B E       T  
#    T   I BBBB  EEEE    T  
#    T   I B   B E       T  
#    T   I BBBB  EEEEE   T  
#
=begin #############################################################
#=Tibet                                                            #
\===`xbg                                                     #
\                                                                  #
\==X[p[NX:                                                 #
$==Super Class:                                                    #
#*EMD+                                                             #
=end ###############################################################

class Tibet < EMD

=begin #########################################################
\==NX \bh:                                            #
$==Class Method:                                               #
=end ###########################################################
  class << self

=begin ***********
#--- Tibet.instance(key)
\  ɑΉCX^X𐶐܂B
\
\    key  CX^Xw肷镶
=end =============
    def instance(key)
      case key
      when /^Tibet$/i
        Tibet.new(
          'Title'=>  'Tibet',
          'MonthNames'=> %w(   p  S    K  X S ), 
          # Ă = [/]
          'LeapNames' => [[0, "%sh"], [2, "[%sh"]],
          'Type' =>   1
        )
      else; nil
      end
    end
  end # of class method

=begin ***********
#--- Tibet.new([quality={})
\  Tibet+IuWFNg𐶐ĕԂ܂B
\
\    quality  @̐`nbV
=end =============
  def initialize(quality={})
    _copy_quality(quality)
    _qualify
  end

=begin #########################################################
\==veNebh CX^X \bh:                       #
$==Prptected Instance Method:                                  #
=end ###########################################################
  protected

=begin ***********
#--- Tibet#_date_to_sdn(y, m=1, d=1)
\  NEEnߒʓɕϊĕԂ܂B
\
\    y  N
\    m  
\    d  
=end =============
  def _date_to_sdn(y, m=1, d=1)
    m = [m,0] unless Array === m
    d = [d,0] unless Array === d
    sdn = _md_to_sdn(_ym_to_smn(y,m), d[0])
    sdn -= 1 if (d[1] < 0)
    return sdn
  end

=begin ***********
#--- Tibet#_sdn_to_date(sdn)
\  nߒʓNEEɕϊĕԂ܂B
\
\    sdn nߒʓ
=end =============
  def _sdn_to_date(sdn)
    mm, dd = _sdn_to_md(sdn)

    # N̒ʂԍ̌
    yy = mm * 65 / (67*12) + Y0 - 4
    while true
      m1 = _ym_to_smn(yy,1)
      break if m1 > mm
      m0 = m1
      yy += 1
    end
    yy -= 1

    # ̒ʂԍ̌
    m   = 1
    while true
      t = _ym_to_smn(yy, m)
      if    (mm - t > 3)
        m += mm - t - 2
      elsif (mm - t > 0)
        m += 1
      else
        break
      end
    end

    # [̔
    mm = [m, ((mm == t) ? 0 : 1)]

    return yy, mm, dd
  end

=begin #########################################################
\==uCx[g CX^X \bh:                         #
$==Private Instance Method:                                    #
=end ###########################################################
  private

  ##############################################################
  #
  # 萔ђ萔郁\bh
  #
  Y0 = 1827           # ̐N
  D0 = 2388440        # ̃EXʓ
  V0 = (6.0+45/60.0)  # r{̃ItZbg
  Am = (2.0+1.0/126)  # ̋ߒn_

  def Z(z,q,d,m,s)
    ((((s/707.0+m)/6.0+d)/60.0+q)/60.0+z)
  end

  def K(k,q,d,m,s)
    ((((s/67.0+m)/6.0+d)/60.0+q)/60.0+k)
  end

  def L(k,q,d,m,s)
    ((((s/13.0+m)/6.0+d)/60.0+q)/60.0+k)
  end

  Rem  = 0 # ]̃CfbNX
  Quot = 1 # ̃CfbNX
  Ddd  = 0 # ̃CfbNX
  Sum  = 1 # ώZl̃CfbNX
  Jm = [   # ̒S
    [ 5, 0], [ 5, 5], [ 5,10], [ 5,15], [ 4,19], [ 3,22], [ 2,24],
    [ 1,25], [-1,24], [-2,22], [-3,19], [-4,15], [-5,10], [-5, 5],
    [-5, 0], [-5,-5]
  ]
  Js = [   # z̒S
    [ 6, 0], [ 6, 6], [ 4,10], [ 1,11], [-1,10], [-4, 6], [-6, 0],
    [-6,-6]
  ]

  ##############################################################
  #
  # z܂͌̈ʒu̒Sɂ鍷
  #
  def Sn(t,m,p)
    t0 = t.floor
    r  = t0.moddiv(m)
    s  = (1.0/60.0)
    s  = -s if r[Quot] % 2 != 0
    return s * (p[r[Rem]][Sum] + (t-t0) * p[r[Rem]+1][Ddd])
  end

  ##############################################################
  #
  # όvZ
  #
  def _ym_to_smn(y, m)
    mm = (y-Y0) * 12 + (m[0] - 3)
    mm += (mm * 2 + @P['M0']).moddiv(65)[Quot]
    mm += 1 if (m[1] > 0)
    return mm
  end

  ##############################################################
  #
  # ϓvZ
  #
  def _md_to_sdn(m, d)
    w    = m * @P['Wo'] + @P['W0'] + d * @P['Wd']  # j
    s    = m * @P['So'] + @P['S0'] + d * @P['Sd']  # 
    sdn  = D0 + w
    sdn += Sn(m*Am+@P['A0']+d, 14, Jm)
    sdn -= Sn((s-V0)*(60.0/135.0), 6, Js)
    return sdn.floor
  end

  #
  # tϓvZ
  #
  def _sdn_to_md(day)
    # ̒ʂԍ̌
    m = ((day-D0)/@P['Wo']).floor - 13
    while true
      t = _md_to_sdn(m,1)
      break if t >= day
      m += (t - day < -94) ?  3 :  1
    end
    m -= 1

    # ̔ԍ̌
    d =  1
    while true
      t = _md_to_sdn(m,d)
      if    (day - t > 3)
        d += day - t - 2
      elsif (day - t > 0)
        d += 1
      else
        break
      end
    end

    # 30zꍇ̏
    if (d >= 31) 
      m += 1
      d -= 30
    end

    # m
    return m , [d, (day >= t) ? 0 : -1]
  end

=begin ***********
#--- Tibet#_qualify
\  Tibet+IuWFNg̐`ݒ肵܂B
\
\  @Type            = ̌nhȂ 1, phȂ 2
\  @P               = zƌ̈ʑvZp̃e[u
=end =============
  def _qualify
    @P = case @Type
         when 1
           {'M0'=>(60+15),
            'Wo'=>Z(29,31,50,0,480),
            'W0'=>Z( 3,37,43,2,140),
            'Wd'=>Z( 0,59, 3,4, 16),
            'So'=>K( 2,10,58,1, 17),
            'S0'=>K(24,59, 6,1, 41),
            'Sd'=>K( 0, 4,21,5, 43),
            'A0'=>22.0
           }
         when 2
           {'M0'=>(64+15),
            'Wo'=>Z(29,31,50,0,  0),
            'W0'=>Z( 3,21,20,0,  0),
            'Wd'=>Z( 0,59, 3,4,  0),
            'So'=>L( 2,10,58,2, 10),
            'S0'=>L(25,42,12,1, 11),
            'Sd'=>L( 0, 4,21,5,  9),
            'A0'=>(22.0+28.0/126)
           }
         end
    super
  end

################################################################
  func :_date_to_sdn, :_sdn_to_date
end
